/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


// Copyright (C) 2002  Antti Kirjavainen


//---------------------------------------------------------------------------
#ifndef FileManagerH
#define FileManagerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TfrmFileManager : public TForm
{
__published:	// IDE-managed Components
        TImageList *imgLarge;
        TImageList *imgSmall;
        TGroupBox *grpLocal;
        TListView *lviLocalDrive;
        TListView *lviLocalFiles;
        TGroupBox *grpRemote;
        TListView *lviRemoteDrive;
        TListView *lviRemoteFiles;
        TMainMenu *mnuMain;
        TMenuItem *mnuFile;
        TMenuItem *mnuRefresh;
        TMenuItem *N1;
        TMenuItem *mnuSelectAll;
        TMenuItem *mnuExecute;
        TMenuItem *mnuPrint;
        TMenuItem *N2;
        TMenuItem *N4;
        TMenuItem *mnuClose;
        TMenuItem *mnuCut;
        TMenuItem *mnuCopy;
        TMenuItem *mnuDelete;
        TMenuItem *mnuRename;
        TMenuItem *mnuShare;
        TMenuItem *mnuRemoveShare;
        TMenuItem *mnuCreate;
        TMenuItem *N5;
        TMenuItem *mnuView;
        TMenuItem *mnuReport;
        TMenuItem *mnuLargeIcons;
        TMenuItem *mnuSmallIcons;
        TMenuItem *mnuList;
        TMenuItem *N6;
        TEdit *txtLocalPath;
        TEdit *txtRemotePath;
        TPopupMenu *mnuRemoteDrive;
        TMenuItem *mnuRemoteDriveProperties;
        TMenuItem *N7;
        TMenuItem *mnuRemoteDriveOpenCDROM;
        TMenuItem *mnuRemoteDriveCloseCDROM;
        TPopupMenu *mnuRemoteFiles;
        TMenuItem *mnuRemoteFolderCreate;
        TMenuItem *mnuRemoteFileCut;
        TMenuItem *mnuRemoteFileCopy;
        TMenuItem *mnuRemoteFileDelete;
        TMenuItem *N8;
        TMenuItem *mnuRemoteFolderShare;
        TMenuItem *mnuRemoteFolderRemoveShare;
        TMenuItem *N9;
        TMenuItem *mnuRemoteFilePaste;
        TMenuItem *mnuPaste;
        TMenuItem *N10;
        TMenuItem *mnuDownload;
        TMenuItem *mnuUpload;
        TMenuItem *N11;
        TMenuItem *mnuRemoteFileDownload;
        TPopupMenu *mnuLocalDrive;
        TMenuItem *mnuLocalDriveProperties;
        TPopupMenu *mnuLocalFiles;
        TMenuItem *mnuLocalFolderCreate;
        TMenuItem *mnuLocalFileCut;
        TMenuItem *mnuLocalFileCopy;
        TMenuItem *mnuLocalFileDelete;
        TMenuItem *mnuLocalFilePaste;
        TMenuItem *MenuItem12;
        TMenuItem *mnuLocalFolderShare;
        TMenuItem *mnuLocalFolderRemoveShare;
        TMenuItem *MenuItem15;
        TMenuItem *mnuLocalFileUpload;
        TMenuItem *MenuItem17;
        TMenuItem *mnuLocalFileProperties;
        TMenuItem *mnuRemoteFileRename;
        TMenuItem *mnuRemoteFileProperties;
        TMenuItem *mnuLocalFileRename;
        TMenuItem *N12;
        TMenuItem *mnuRemoteFileExecute;
        TMenuItem *mnuRemoteFilePrint;
        TMenuItem *N13;
        TMenuItem *mnuLocalFileExecute;
        TMenuItem *mnuLocalFilePrint;
        TButton *cmdRemoteFileUp;
        TButton *cmdLocalFileUp;
        TPopupMenu *mnuRemoteFilesSingle;
        TMenuItem *mnuRemoteFileSingleCreate;
        TPopupMenu *mnuLocalFilesSingle;
        TMenuItem *mnuLocalFileSingleCreate;
        TMemo *txtClipboard;
        TMenuItem *mnuRemoteFileSinglePaste;
        TMenuItem *mnuLocalFileSinglePaste;
        TMenuItem *N3;
        TMenuItem *N14;
        TMenuItem *mnuProperties;
        TMenuItem *N15;
        TMenuItem *mnuLocalDriveOpenCDROM;
        TMenuItem *mnuLocalDriveCloseCDROM;
        void __fastcall mnuCloseClick(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall mnuLargeIconsClick(TObject *Sender);
        void __fastcall mnuSmallIconsClick(TObject *Sender);
        void __fastcall mnuListClick(TObject *Sender);
        void __fastcall mnuReportClick(TObject *Sender);
        void __fastcall mnuSelectAllClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall mnuRemoteFilePropertiesClick(TObject *Sender);
        void __fastcall mnuRemoteDrivePropertiesClick(TObject *Sender);
        void __fastcall lviRemoteFilesEdited(TObject *Sender,
          TListItem *Item, AnsiString &S);
        void __fastcall lviLocalFileEdited(TObject *Sender,
          TListItem *Item, AnsiString &S);
        void __fastcall lviLocalFilesEdited(TObject *Sender,
          TListItem *Item, AnsiString &S);
        void __fastcall mnuRefreshClick(TObject *Sender);
        void __fastcall lviRemoteFilesDblClick(TObject *Sender);
        void __fastcall lviRemoteDriveDblClick(TObject *Sender);
        void __fastcall mnuRemoteFileRenameClick(TObject *Sender);
        void __fastcall mnuLocalFileRenameClick(TObject *Sender);
        void __fastcall mnuRemoteFolderCreateClick(TObject *Sender);
        void __fastcall mnuLocalFolderCreateClick(TObject *Sender);
        void __fastcall mnuPrintClick(TObject *Sender);
        void __fastcall mnuExecuteClick(TObject *Sender);
        void __fastcall mnuFileClick(TObject *Sender);
        void __fastcall CheckSelected();
        void __fastcall SendFileCommand(const AnsiString wCommand, const AnsiString sPath, TListView * lviObject, const bool forDir);
        void __fastcall lviRemoteFilesMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall lviLocalFilesMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall UncheckMenu();
        void __fastcall txtRemotePathKeyPress(TObject *Sender, char &Key);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall mnuRemoteFileDeleteClick(TObject *Sender);
        AnsiString __fastcall ListSelected(TListView * lviObject, const AnsiString sPath);
        void __fastcall mnuLocalFileDeleteClick(TObject *Sender);
        bool __fastcall IsFolder(TListView * lviObject, const int lviIndex);
        void __fastcall mnuRemoteFolderShareClick(TObject *Sender);
        void __fastcall mnuLocalFolderShareClick(TObject *Sender);
        void __fastcall mnuShareClick(TObject *Sender);
        void __fastcall mnuRemoveShareClick(TObject *Sender);
        void __fastcall mnuRemoteFileExecuteClick(TObject *Sender);
        void __fastcall mnuLocalFileExecuteClick(TObject *Sender);
        void __fastcall mnuRemoteFilePrintClick(TObject *Sender);
        void __fastcall mnuLocalFilePrintClick(TObject *Sender);
        void __fastcall lviRemoteDriveMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall lviLocalDriveMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall mnuRemoteDriveOpenCDROMClick(TObject *Sender);
        void __fastcall mnuRemoteDriveCloseCDROMClick(TObject *Sender);
        void __fastcall cmdRemoteFileUpClick(TObject *Sender);
        void __fastcall mnuCreateClick(TObject *Sender);
        void __fastcall mnuRenameClick(TObject *Sender);
        void __fastcall mnuCutClick(TObject *Sender);
        void __fastcall mnuCopyClick(TObject *Sender);
        void __fastcall mnuDeleteClick(TObject *Sender);
        void __fastcall mnuPasteClick(TObject *Sender);
        void __fastcall mnuRemoteFolderRemoveShareClick(TObject *Sender);
        void __fastcall mnuLocalFolderRemoveShareClick(TObject *Sender);
        void __fastcall lviLocalDriveDblClick(TObject *Sender);
        void __fastcall GetLocalList(const AnsiString sPath);
        void __fastcall lviLocalFilesDblClick(TObject *Sender);
        void __fastcall cmdLocalFileUpClick(TObject *Sender);
        void __fastcall txtLocalPathKeyPress(TObject *Sender, char &Key);
        void __fastcall mnuRemoteFileDownloadClick(TObject *Sender);
        void __fastcall AddToClipboard(const AnsiString sType, const AnsiString sPath, TListView * sObject);
        void __fastcall PasteClipboard(const AnsiString sPath);
        void __fastcall mnuRemoteFileCutClick(TObject *Sender);
        void __fastcall mnuRemoteFileCopyClick(TObject *Sender);
        void __fastcall mnuRemoteFilePasteClick(TObject *Sender);
        void __fastcall mnuLocalFilePasteClick(TObject *Sender);
        void __fastcall mnuLocalFileCopyClick(TObject *Sender);
        void __fastcall mnuLocalFileCutClick(TObject *Sender);
        void __fastcall mnuPropertiesClick(TObject *Sender);
        void __fastcall mnuLocalFileUploadClick(TObject *Sender);
        void __fastcall mnuLocalDriveOpenCDROMClick(TObject *Sender);
        void __fastcall mnuLocalDriveCloseCDROMClick(TObject *Sender);
        void __fastcall lviRemoteFilesStartDrag(TObject *Sender,
          TDragObject *&DragObject);
        void __fastcall lviLocalFilesStartDrag(TObject *Sender,
          TDragObject *&DragObject);
        void __fastcall lviRemoteFilesDragOver(TObject *Sender,
          TObject *Source, int X, int Y, TDragState State, bool &Accept);
        void __fastcall lviLocalFilesDragOver(TObject *Sender,
          TObject *Source, int X, int Y, TDragState State, bool &Accept);
        void __fastcall lviRemoteFilesDragDrop(TObject *Sender,
          TObject *Source, int X, int Y);
        void __fastcall lviLocalFilesDragDrop(TObject *Sender,
          TObject *Source, int X, int Y);

private:	// User declarations
public:		// User declarations
        __fastcall TfrmFileManager(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmFileManager *frmFileManager;
//---------------------------------------------------------------------------
#endif
