/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

frmFind
Part of the Specrem-project.

Find files from the remote computer.
Copyright (C) 2002  Antti Kirjavainen

*/


//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Find.h"
#include "Public.cpp"
#include "Main.h"
#include "..\Shared\strHandle.cpp"
#include "..\Shared\Commands.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmFind *frmFind;

//---------------------------------------------------------------------------
__fastcall TfrmFind::TfrmFind(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmFind::mnuCloseClick(TObject *Sender)
{
this->Close();
}
//---------------------------------------------------------------------------

void SendWindowCommand(AnsiString wCommand, AnsiString wParams)
{
int w;

for (w = 0; w < frmFind->lviFind->Items->Count; ++w)
        {
        if (frmFind->lviFind->Items->Item[w]->Selected) frmMain->SendCommand(wCommand, frmFind->lviFind->Items->Item[w]->Caption + wParams, frmFind->Tag);
        }
}



void __fastcall TfrmFind::FormCreate(TObject *Sender)
{

if (FileExists(ExtractFilePath(Application->ExeName) + "Language.INI"))
{
mnuFile->Caption = ReadFromLanguage("General", "mnuFile", mnuFile->Caption);
mnuClose->Caption = ReadFromLanguage("General", "mnuClose", mnuClose->Caption);

this->Caption = DelHK(ReadFromLanguage("ClientMain", "mnuFind", this->Caption));

cmdSearch->Caption = ReadFromLanguage("Find", "cmdSearch", cmdSearch->Caption);
grpFind->Caption = this->Caption;
lblSearchThisFolder->Caption = ReadFromLanguage("Find", "lblFolder", lblSearchThisFolder->Caption);
lblLookForTheseFiles->Caption = ReadFromLanguage("Find", "lblFiles", lblLookForTheseFiles->Caption);
chkIncludeSubfolders->Caption = ReadFromLanguage("Find", "chkSubFolders", chkIncludeSubfolders->Caption);
mnuView->Caption = ReadFromLanguage("ServerMain", "mnuView", mnuView->Caption);
mnuReport->Caption = ReadFromLanguage("General", "mnuDetailIcons", mnuReport->Caption);
mnuLargeIcons->Caption = ReadFromLanguage("General", "mnuLargeIcons", mnuLargeIcons->Caption);
mnuSmallIcons->Caption = ReadFromLanguage("General", "mnuSmallIcons", mnuSmallIcons->Caption);
mnuList->Caption = ReadFromLanguage("General", "mnuListIcons", mnuList->Caption);

lviFind->Column[1]->Caption = ReadFromLanguage("File", "File", "File");
lviFind->Column[2]->Caption = ReadFromLanguage("File", "Size", "Size");
//lviFind->Column[3]->Caption = ReadFromLanguage("File", "Created", "Created");
//lviFind->Column[4]->Caption = ReadFromLanguage("File", "Modified", "Modified");


mnuSelectAll->Caption = ReadFromLanguage("General", "mnuSelectAll", mnuSelectAll->Caption);
mnuDownload->Caption = ReadFromLanguage("ClientMain", "mnuDownload", mnuDownload->Caption);
mnuDelete->Caption = ReadFromLanguage("ClientMain", "mnuDeleteFile", mnuDelete->Caption);
mnuRename->Caption = ReadFromLanguage("ClientMain", "mnuRename", mnuRename->Caption);
mnuProperties->Caption = ReadFromLanguage("General", "mnuProperties", mnuProperties->Caption);

mnuSelectAll2->Caption = mnuSelectAll->Caption;
mnuDownload2->Caption = mnuDownload->Caption;
mnuDelete2->Caption = mnuDelete->Caption;
mnuRename2->Caption = mnuRename->Caption;
mnuProperties2->Caption = mnuProperties->Caption;
}

}
//---------------------------------------------------------------------------

void SetViewStyle(TViewStyle newStyle)
{
frmFind->mnuLargeIcons->Checked = False;
frmFind->mnuSmallIcons->Checked = False;
frmFind->mnuList->Checked = False;
frmFind->mnuReport->Checked = False;

if (newStyle == vsIcon) frmFind->mnuLargeIcons->Checked = True;
if (newStyle == vsSmallIcon) frmFind->mnuSmallIcons->Checked = True;
if (newStyle == vsList) frmFind->mnuList->Checked = True;
if (newStyle == vsReport) frmFind->mnuReport->Checked = True;

frmFind->lviFind->ViewStyle = newStyle;
}



void __fastcall TfrmFind::mnuLargeIconsClick(TObject *Sender)
{
SetViewStyle(vsIcon);        
}
//---------------------------------------------------------------------------

void __fastcall TfrmFind::mnuSmallIconsClick(TObject *Sender)
{
SetViewStyle(vsSmallIcon);
}
//---------------------------------------------------------------------------

void __fastcall TfrmFind::mnuListClick(TObject *Sender)
{
SetViewStyle(vsList);
}
//---------------------------------------------------------------------------

void __fastcall TfrmFind::mnuReportClick(TObject *Sender)
{
SetViewStyle(vsReport);
}
//---------------------------------------------------------------------------

void __fastcall TfrmFind::lviFindMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (lviFind->SelCount == 0) return;

if (Button == mbRight)
                     {
                     tagPOINT CursorPos;
                     GetCursorPos(&CursorPos);

                     mnuPopUp->Popup(CursorPos.x, CursorPos.y);
                     }
}
//---------------------------------------------------------------------------

void __fastcall TfrmFind::mnuSelectAllClick(TObject *Sender)
{
lviFind->SelectAll();
}
//---------------------------------------------------------------------------

void __fastcall TfrmFind::mnuFileClick(TObject *Sender)
{
if (lviFind->SelCount == 0)
                          {
                          mnuDownload->Enabled = False;
                          mnuDelete->Enabled = False;
                          mnuRename->Enabled = False;
                          mnuProperties->Enabled = False;
                          }
                          else
                          {
                          mnuDownload->Enabled = True;
                          mnuDelete->Enabled = True;
                          mnuRename->Enabled = True;
                          mnuProperties->Enabled = True;
                          }
}
//---------------------------------------------------------------------------

void __fastcall TfrmFind::FormResize(TObject *Sender)
{
lviFind->Width = this->Width - 22;
lviFind->Height = this->Height - 237;
}
//---------------------------------------------------------------------------

void __fastcall TfrmFind::cmdSearchClick(TObject *Sender)
{
if (txtPath->Text == "") return;

DisableEnableControls(frmFind->grpFind, False);

animFind->Active = True;
//this->Cursor = crAppStart;
cmdSearch->Caption = ReadFromLanguage("Find", "cmdSearching", "Searching...");
cmdSearch->Enabled = False;
frmMain->SendCommand(COMMAND_FILE_FIND, txtPath->Text + SEPARATOR_SINGLE + txtFiles->Text, this->Tag);
}
//---------------------------------------------------------------------------


void __fastcall TfrmFind::mnuRenameClick(TObject *Sender)
{
lviFind->ItemFocused->EditCaption();
}
//---------------------------------------------------------------------------

void __fastcall TfrmFind::mnuPropertiesClick(TObject *Sender)
{
//SendWindowCommand(COMMAND_FILE_PROPERTIES, "");
}
//---------------------------------------------------------------------------

void __fastcall TfrmFind::mnuDownloadClick(TObject *Sender)
{
//
}
//---------------------------------------------------------------------------

void __fastcall TfrmFind::lviFindEdited(TObject *Sender, TListItem *Item,
      AnsiString &S)
{
frmMain->SendCommand(COMMAND_FILE_RENAME, Item->Caption + SEPARATOR_SINGLE + S, this->Tag);
}
//---------------------------------------------------------------------------

void AddToClipBoard(bool Copy)
{
if (frmFind->lviFind->SelCount == 0) return;
//strClipBoard->Clear();
//if (Copy) { strClipBoard->Add("C"); } else { strClipBoard->Add("M"); }

unsigned short int c;

for (c = 0; c < frmFind->lviFind->Items->Count; ++c)
        {
        //if (frmFind->lviFind->Items->Item[c]->Selected) strClipBoard->Add(frmFind->lviFind->Items->Item[c]->Caption);
        }

}

void __fastcall TfrmFind::mnuCopyClick(TObject *Sender)
{
AddToClipBoard(True);
}
//---------------------------------------------------------------------------

void __fastcall TfrmFind::mnuCutClick(TObject *Sender)
{
AddToClipBoard(False);
}
//---------------------------------------------------------------------------

void __fastcall TfrmFind::mnuDeleteClick(TObject *Sender)
{
AnsiString msg;
AnsiString msg2;

msg = ReadFromLanguage("InputBox", "msgDelete", "Are you sure you want to delete the selected files/folders?");
msg2 = DelHK(ReadFromLanguage("ClientMain", "mnuDeleteFile", "Delete"));

if (MessageBox(Application->Handle, msg.c_str(), msg2.c_str(), 4) != mrYes) return;

SendWindowCommand(COMMAND_FILE_DELETE, "");
}
//---------------------------------------------------------------------------

