/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

Grouping.cpp
Part of the Specrem-project.

Client address book grouping.
Copyright (C) 2002  Antti Kirjavainen

*/


//---------------------------------------------------------------------------
#include <vcl.h>
#include "Main.h"

void ReadGroups();
void SaveAddresses();
void OpenGroup(const AnsiString GroupName);

TfrmMain * frmMain;

void SaveAddresses()
{
// Save the address list:

unsigned short int l;
AnsiString curGroup;
AnsiString strl;


//frmMain->lviAddress->SortType = ::stBoth;
//frmMain->lviAddress->SortType = ::stNone;
frmMain->lviAddress->SortType = 4;
frmMain->lviAddress->SortType = 0;
curGroup = "Group_" + frmMain->cboGroup->Text;

for (l = 0; l < 500; ++l)
        {
        strl = IntToStr(l);

        if (l >= frmMain->lviAddress->Items->Count)
                                                  {
                                                  if (frmMain->ReadFromINI(curGroup, "Address" + strl, "") == "")
                                                                                              {
                                                                                              // No old sections found.
                                                                                              return;
                                                                                              }
                                                                                              else
                                                                                              {
                                                                                              // Let's erase the old sections:
                                                                                              frmMain->WriteToINI(curGroup, "Address" + strl, "");
                                                                                              frmMain->WriteToINI(curGroup, "Port" + strl, "");
                                                                                              frmMain->WriteToINI(curGroup, "Router" + strl, "");
                                                                                              frmMain->WriteToINI(curGroup, "NIC" + strl, "");
                                                                                              }
                                                  continue;
                                                  }

        frmMain->WriteToINI(curGroup, "Address" + strl, frmMain->lviAddress->Items->Item[l]->Caption);
        if (frmMain->lviAddress->Items->Item[l]->SubItems->Count >= 1) frmMain->WriteToINI(curGroup, "Port" + strl, frmMain->lviAddress->Items->Item[l]->SubItems->Strings[0]);
        if (frmMain->lviAddress->Items->Item[l]->SubItems->Count >= 2) frmMain->WriteToINI(curGroup, "Router" + strl, frmMain->lviAddress->Items->Item[l]->SubItems->Strings[1]);
        if (frmMain->lviAddress->Items->Item[l]->SubItems->Count >= 3) frmMain->WriteToINI(curGroup, "NIC" + strl, frmMain->lviAddress->Items->Item[l]->SubItems->Strings[2]);
        }



}


void ReadGroups()
{
// Read the group list:

unsigned short int g;
AnsiString GroupRead;

if (frmMain->ReadFromINI("Groups", "Group0", "") == "") frmMain->WriteToINI("Groups", "Group0", "Default");

for (g = 0; g < 500; ++g)
        {
        GroupRead = frmMain->ReadFromINI("Groups", "Group" + IntToStr(g), "");
        if (GroupRead == "")
                           {
                           break;
                           }
                           else
                           {
                           frmMain->cboGroup->AddItem(GroupRead, frmMain->cboGroup);
                           }
        }

if (frmMain->cboGroup->Items->Count > 0)
                                        {
                                        frmMain->cboGroup->Text = frmMain->cboGroup->Items->Strings[0];
                                        OpenGroup(frmMain->cboGroup->Text);
                                        }
}


void OpenGroup(const AnsiString GroupName)
{

// Read info from the selected group:

unsigned short int g;
AnsiString GroupRead;
AnsiString GroupRead2;
AnsiString curGroup;

frmMain->lviAddress->Clear();


for (g = 0; g < 500; ++g)
        {
        curGroup = "Group_" + GroupName;
        GroupRead = frmMain->ReadFromINI(curGroup, "Address" + IntToStr(g), "");
        GroupRead2 = frmMain->ReadFromINI(curGroup, "Port" + IntToStr(g), "") + "\r" +
                                        frmMain->ReadFromINI(curGroup, "Router" + IntToStr(g), "") + "\r" +
                                                        frmMain->ReadFromINI(curGroup, "NIC" + IntToStr(g), "");
        if (GroupRead == "")
                          {
                          return;
                          }
                          else
                          {
                          frmMain->lviAddress->AddItem(GroupRead, frmMain->lviAddress);
                          frmMain->lviAddress->Items->Item[frmMain->lviAddress->Items->Count - 1]->SubItems->Text = GroupRead2;
                          }
        }
}

