/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


// Copyright (C) 2002  Antti Kirjavainen


//---------------------------------------------------------------------------
#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
#include <ComCtrls.hpp>
#include <ScktComp.hpp>
#include <IdBaseComponent.hpp>
#include <IdComponent.hpp>
#include <IdHTTP.hpp>
#include <IdHTTPServer.hpp>
#include <IdTCPClient.hpp>
#include <IdTCPConnection.hpp>
#include <IdTCPServer.hpp>
#include <ExtCtrls.hpp>
#include "trayicon.h"
//---------------------------------------------------------------------------
class TfrmMain : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *mnuMain;
        TMenuItem *mnuFile;
        TMenuItem *mnuConnect;
        TMenuItem *mnuCallback;
        TMenuItem *N1;
        TMenuItem *mnuOptions;
        TMenuItem *N2;
        TMenuItem *mnuExit;
        TMenuItem *mnuRemoteControl;
        TMenuItem *mnuRemoteControl2;
        TMenuItem *mnuSimpleMouse;
        TMenuItem *mnuFullControl;
        TMenuItem *mnuExecute;
        TMenuItem *mnuHostOptions;
        TMenuItem *N3;
        TMenuItem *mnuHostInfo;
        TMenuItem *mnuHostInformation;
        TMenuItem *mnuHostUsers;
        TMenuItem *mnuHostVersion;
        TMenuItem *N4;
        TMenuItem *mnuCommandLine;
        TMenuItem *mnuFileMngr;
        TMenuItem *mnuFindFiles;
        TMenuItem *mnuFileManager;
        TMenuItem *mnuVolumeControl;
        TMenuItem *mnuTaskManager;
        TMenuItem *mnuCoolFunctions;
        TMenuItem *mnuDisableControl;
        TMenuItem *N5;
        TMenuItem *mnuChat;
        TMenuItem *mnuSendMessage;
        TMenuItem *mnuSpyFunctions;
        TMenuItem *mnuKeyboardListen;
        TMenuItem *mnuMouseListen;
        TMenuItem *N6;
        TMenuItem *mnuScreenSpy;
        TMenuItem *mnuScreenshot;
        TMenuItem *mnuWebcam;
        TMenuItem *mnuShutdownMenu;
        TMenuItem *mnuStopShutdown;
        TMenuItem *N7;
        TMenuItem *mnuCloseServer;
        TMenuItem *mnuRestartServer;
        TMenuItem *N8;
        TMenuItem *mnuLogoff;
        TMenuItem *mnuReboot;
        TMenuItem *mnuShutdown;
        TMenuItem *mnuForceShutdown;
        TMenuItem *N9;
        TMenuItem *mnuStartScreensaver;
        TMenuItem *mnuLockComputer;
        TMenuItem *mnuHelp;
        TMenuItem *mnuHelpFile;
        TMenuItem *mnuHomepage;
        TMenuItem *N10;
        TMenuItem *mnuSendABugReport;
        TMenuItem *mnuUpdate;
        TMenuItem *N11;
        TMenuItem *mnuAbout;
        TPopupMenu *mnuPopUp;
        TMenuItem *mnuConnect2;
        TMenuItem *N12;
        TMenuItem *mnuAdd;
        TMenuItem *mnuRemove;
        TMenuItem *N13;
        TMenuItem *mnuAdd2;
        TMenuItem *mnuRemove2;
        TMenuItem *mnuSelectAll;
        TMenuItem *mnuSelectAll2;
        TMenuItem *N14;
        TImageList *imgLarge;
        TImageList *imgSmall;
        TListView *lviAddress;
        TStatusBar *sttStatus;
        TMenuItem *mnuView;
        TMenuItem *mnuLargeIcons;
        TMenuItem *mnuSmallIcons;
        TMenuItem *N15;
        TMenuItem *mnuReport;
        TMenuItem *mnuList;
        TServerSocket *sckCallback;
        TMenuItem *mnuAboutTranslation;
        TMenuItem *mnuEdit;
        TMenuItem *mnuEdit2;
        TComboBox *cboGroup;
        TMemo *txtTemp;
        TTimer *tmrSave;
        TTrayIcon *ttIcon;
        TPopupMenu *mnuPopUpTray;
        TMenuItem *mnuOptions2;
        TMenuItem *N16;
        TMenuItem *mnuExit2;
        TMenuItem *mnuCallback2;
        TMenuItem *N17;
        TMenuItem *mnuConnect3;
        TMenuItem *mnuWork;
        TMemo *txtLog;
        TMenuItem *mnuMonitorOff;
        void __fastcall FormResize(TObject *Sender);
        void __fastcall mnuLargeIconsClick(TObject *Sender);
        void __fastcall mnuExitClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall mnuShutdownClick(TObject *Sender);
        void __fastcall mnuRebootClick(TObject *Sender);
        void __fastcall mnuLogoffClick(TObject *Sender);
        void __fastcall mnuForceShutdownClick(TObject *Sender);
        void __fastcall mnuConnectClick(TObject *Sender);
        void __fastcall lviAddressMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall mnuUpdateClick(TObject *Sender);
        void __fastcall mnuHelpFileClick(TObject *Sender);
        void __fastcall mnuHomepageClick(TObject *Sender);
        void __fastcall mnuSendABugReportClick(TObject *Sender);
        void __fastcall mnuDisableControlClick(TObject *Sender);
        void __fastcall mnuSendMessageClick(TObject *Sender);
        void __fastcall mnuHostVersionClick(TObject *Sender);
        void __fastcall mnuCloseServerClick(TObject *Sender);
        void __fastcall mnuRestartServerClick(TObject *Sender);
        void __fastcall mnuStopShutdownClick(TObject *Sender);
        void __fastcall mnuStartScreensaverClick(TObject *Sender);
        void __fastcall mnuLockComputerClick(TObject *Sender);
        void __fastcall mnuExecuteClick(TObject *Sender);
        void __fastcall mnuAboutClick(TObject *Sender);
        void __fastcall mnuCommandLineClick(TObject *Sender);
        void __fastcall cboGroupKeyPress(TObject *Sender, char &Key);
        void __fastcall mnuSelectAllClick(TObject *Sender);
        void __fastcall mnuEditClick(TObject *Sender);
        void __fastcall mnuSmallIconsClick(TObject *Sender);
        void __fastcall mnuListClick(TObject *Sender);
        void __fastcall mnuReportClick(TObject *Sender);
        void __fastcall lviAddressDblClick(TObject *Sender);
        void __fastcall lviAddressKeyPress(TObject *Sender, char &Key);
        void __fastcall sckCommandDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sckCommandConnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall mnuCallbackClick(TObject *Sender);
        void __fastcall mnuFindFilesClick(TObject *Sender);
        void __fastcall mnuTaskManagerClick(TObject *Sender);
        void __fastcall mnuHostUsersClick(TObject *Sender);
        void __fastcall mnuAdd2Click(TObject *Sender);
        void __fastcall cboGroupSelect(TObject *Sender);
        void __fastcall mnuRemove2Click(TObject *Sender);
        void __fastcall tmrSaveTimer(TObject *Sender);
        void __fastcall mnuHostOptionsClick(TObject *Sender);
        void __fastcall sckCommandRead(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sckCallbackClientConnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall mnuOptionsClick(TObject *Sender);
        void __fastcall sckCallbackClientDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        int __fastcall SendCommand(const AnsiString sCommand, const AnsiString sParams, const unsigned int sHandle);
        void __fastcall sckCommandError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
        void __fastcall mnuSimpleMouseClick(TObject *Sender);
        void __fastcall mnuFullControlClick(TObject *Sender);
        void __fastcall mnuChatClick(TObject *Sender);
void __fastcall WriteToINI(const AnsiString sSection, const AnsiString sKey, const AnsiString sValue);
void __fastcall WriteToINIBool(const AnsiString sSection, const AnsiString sKey, const bool sValue);
AnsiString __fastcall ReadFromINI(const AnsiString sSection, const AnsiString sKey, const AnsiString sDefault);
bool __fastcall ReadFromINIBool(const AnsiString sSection, const AnsiString sKey, const bool sDefault);
        void __fastcall sckFileInstConnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sckFileInstDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sckFileInstError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
        void __fastcall sckFileInstRead(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall mnuScreenshotClick(TObject *Sender);
void __fastcall SetFilename(const AnsiString newFileName, const unsigned int sHandle);
        void __fastcall mnuWorkClick(TObject *Sender);
        void __fastcall mnuMouseListenClick(TObject *Sender);
        void __fastcall tmrPingTimer(TObject *Sender);
int __fastcall OpenFile(const AnsiString FileName, const unsigned int sHandle, const __int64 ResumeSize, const bool CreateIfNotFound);
        void __fastcall mnuFileManagerClick(TObject *Sender);
        void __fastcall mnuFileMngrClick(TObject *Sender);
        void __fastcall mnuHostInfoClick(TObject *Sender);
        void __fastcall mnuRemoteControl2Click(TObject *Sender);
        void __fastcall tmrProgressTimer(TObject *Sender);
void __fastcall StopTransfer(const unsigned int sHandle);
void __fastcall PasswordEntered(const AnsiString sPassword);
int __fastcall IsReserved(const unsigned int sHandle);
void __fastcall ShowScreenPart(const unsigned int sHandle, const bool Done);
        void __fastcall mnuScreenSpyClick(TObject *Sender);
        void __fastcall mnuWebcamClick(TObject *Sender);
        void __fastcall mnuHostInformationClick(TObject *Sender);
void __fastcall SaveAddresses();
void __fastcall ReadGroups();
void __fastcall OpenGroup(const AnsiString GroupName);
void __fastcall Status(const AnsiString StatusText);
void __fastcall CheckMenus();
        void __fastcall mnuFileClick(TObject *Sender);
int __fastcall SplitToListView(TListView * lviObject, const AnsiString pData);
AnsiString __fastcall HandleToHostname(const unsigned int sHandle);
void __fastcall TypeCommandLine(unsigned int sHandle, AnsiString sText);
void __fastcall SwitchIcon(TListView * lviObject, const unsigned int newColumnIndex, const unsigned int newImageIndex, const AnsiString TextToFind);

private:	// User declarations
public:		// User declarations
        __fastcall TfrmMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMain *frmMain;
//---------------------------------------------------------------------------
#endif
