/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

frmRemoteControl
Part of the Specrem-project.

Simple mouse and key, Full control and Screen spy.
Copyright (C) 2002  Antti Kirjavainen

*/


//---------------------------------------------------------------------------
#include <vcl.h>
#include "Public.cpp"
#include "Main.h"
#include "..\Shared\Commands.h"
#pragma hdrstop

#include "RemoteControl.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
tagPoint lastPos;
unsigned short int lastX;
unsigned short int lastY;
TfrmRemoteControl *frmRemoteControl;
//---------------------------------------------------------------------------
__fastcall TfrmRemoteControl::TfrmRemoteControl(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmRemoteControl::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (tmrMouseMove->Tag != 1) return;
if (X == lastX && Y == lastY) return;

frmMain->SendCommand(COMMAND_REMOTE_MOUSE_MOVE, IntToStr(X) + SEPARATOR_SPLIT + IntToStr(Y), this->Tag);
lastX = X;
lastY = Y;
}
//---------------------------------------------------------------------------
void __fastcall TfrmRemoteControl::mnuCloseClick(TObject *Sender)
{
this->Close();
}
//---------------------------------------------------------------------------


void __fastcall TfrmRemoteControl::FormCreate(TObject *Sender)
{
mnuRefresh->Caption = ReadFromLanguage("General", "Refresh", mnuRefresh->Caption);
mnuClose->Caption = ReadFromLanguage("General", "mnuClose", mnuClose->Caption);
mnuFile->Caption = ReadFromLanguage("General", "mnuFile", mnuFile->Caption);
mnuGetClipboard->Caption = ReadFromLanguage("ClientMain", "mnuGetClip", mnuGetClipboard->Caption);
mnuSetClipboard->Caption = ReadFromLanguage("ClientMain", "mnuSetClip", mnuSetClipboard->Caption);
}
//---------------------------------------------------------------------------

void __fastcall TfrmRemoteControl::tmrMouseMoveTimer(TObject *Sender)
{
tagPoint curPos;

if (&lastPos == &curPos) return;

GetCursorPos(&curPos);
lastPos = curPos;
frmMain->SendCommand(COMMAND_REMOTE_MOUSE_MOVE, IntToStr(curPos.x) + SEPARATOR_SPLIT + IntToStr(curPos.y), 0);
}
//---------------------------------------------------------------------------


void __fastcall TfrmRemoteControl::FormKeyPress(TObject *Sender, char &Key)
{
frmMain->SendCommand(COMMAND_REMOTE_KEYBOARD_PRESS, IntToStr(Key), 0);
}
//---------------------------------------------------------------------------

void __fastcall TfrmRemoteControl::FormClose(TObject *Sender,
      TCloseAction &Action)
{
tmrMouseMove->Tag = -1;
frmMain->SendCommand(COMMAND_SCREEN_VIEW, PARAMETER_STOP, 0);
}
//---------------------------------------------------------------------------

void __fastcall TfrmRemoteControl::mnuRefreshClick(TObject *Sender)
{
if (tmrMouseMove->Tag == 2) { frmMain->SendCommand(COMMAND_WEBCAMSHOT, "", this->Tag); } else {frmMain->SendCommand(COMMAND_SCREENSHOT, "", this->Tag); }
}
//---------------------------------------------------------------------------

void __fastcall TfrmRemoteControl::mnuFileClick(TObject *Sender)
{
/*
if (tmrMouseMove->Tag == 2 || tmrMouseMove->Tag == 3)
                           {
                           mnuRefresh->Visible = true;
                           N3->Visible = true;
                           }
                           else
                           {
                           mnuRefresh->Visible = false;
                           N3->Visible = false;
                           }
*/
}
//---------------------------------------------------------------------------

void __fastcall TfrmRemoteControl::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (tmrMouseMove->Tag != 1) return;

if (Button == mbLeft) frmMain->SendCommand(COMMAND_REMOTE_MOUSE_DOWN, PARAMETER_LEFT, this->Tag);
if (Button == mbMiddle) frmMain->SendCommand(COMMAND_REMOTE_MOUSE_DOWN, PARAMETER_MIDDLE, this->Tag);
if (Button == mbRight) frmMain->SendCommand(COMMAND_REMOTE_MOUSE_DOWN, PARAMETER_RIGHT, this->Tag);
}
//---------------------------------------------------------------------------

void __fastcall TfrmRemoteControl::FormMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (tmrMouseMove->Tag != 1) return;

if (Button == mbLeft) frmMain->SendCommand(COMMAND_REMOTE_MOUSE_UP, PARAMETER_LEFT, this->Tag);
if (Button == mbMiddle) frmMain->SendCommand(COMMAND_REMOTE_MOUSE_UP, PARAMETER_MIDDLE, this->Tag);
if (Button == mbRight) frmMain->SendCommand(COMMAND_REMOTE_MOUSE_UP, PARAMETER_RIGHT, this->Tag);
}
//---------------------------------------------------------------------------

void __fastcall TfrmRemoteControl::FormDblClick(TObject *Sender)
{
if (tmrMouseMove->Tag != 1) return;

frmMain->SendCommand(COMMAND_REMOTE_MOUSE_DBLCLICK, "", this->Tag);
}
//---------------------------------------------------------------------------

