/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

frmTaskManager
Part of the Specrem-project.

Task manager.
Copyright (C) 2002  Antti Kirjavainen

*/


//---------------------------------------------------------------------------
#include <vcl.h>
#include "Public.cpp"
#include "Main.h"
#include "Execute.h"
#include "..\Shared\Commands.h"
#include "..\Shared\strHandle.cpp"
#pragma hdrstop

#include "TaskManager.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmTaskManager *frmTaskManager;



//---------------------------------------------------------------------------
__fastcall TfrmTaskManager::TfrmTaskManager(TComponent* Owner)
        : TForm(Owner)
{


}
//---------------------------------------------------------------------------
void __fastcall TfrmTaskManager::tmrGetMousePositionTimer(
      TObject *Sender)
{
tagPOINT CursorPos;
GetCursorPos(&CursorPos);

txtMouseX->Text = IntToStr(CursorPos.x);
txtMouseY->Text = IntToStr(CursorPos.y);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::SendWindowCommand(const AnsiString wCommand, const AnsiString wParams, const bool rRefresh)
{
int w;

for (w = 0; w < lviWindows->Items->Count; ++w)
        {
        if (lviWindows->Items->Item[w]->Selected) frmMain->SendCommand(wCommand, lviWindows->Items->Item[w]->Caption + wParams, this->Tag);
        }

if (rRefresh) mnuRefresh->Click();
}


void __fastcall TfrmTaskManager::FormCreate(TObject *Sender)
{

if (FileExists(ExtractFilePath(Application->ExeName) + "Language.INI"))
{
this->Caption = ReadFromLanguage("ClientMain", "mnuTaskManager", this->Caption);
mnuFile->Caption = ReadFromLanguage("General", "mnuFile", mnuFile->Caption);
mnuClose->Caption = ReadFromLanguage("General", "mnuClose", mnuClose->Caption);
mnuSelectAll->Caption = ReadFromLanguage("General", "mnuSelectAll", mnuSelectAll->Caption);
mnuRefresh->Caption = ReadFromLanguage("General", "Refreshing", mnuRefresh->Caption);
mnuVisibleWindowsOnly->Caption = ReadFromLanguage("WindowManager", "chkVisible", mnuVisibleWindowsOnly->Caption);
chkGetMousePosition->Caption = ReadFromLanguage("WindowManager", "chkGetMousePosition", chkGetMousePosition->Caption);
mnuEndTask->Caption = ReadFromLanguage("WindowManager", "mnuEndTask", mnuEndTask->Caption);
mnuFreeze->Caption = ReadFromLanguage("WindowManager", "mnuFreeze", mnuFreeze->Caption);
mnuUnfreeze->Caption = ReadFromLanguage("WindowManager", "mnuUnFreeze", mnuUnfreeze->Caption);
mnuMaximize->Caption = ReadFromLanguage("WindowManager", "mnuMaximize", mnuMaximize->Caption);
mnuMinimize->Caption = ReadFromLanguage("WindowManager", "mnuMinimize", mnuMinimize->Caption);
mnuSwitchTo->Caption = ReadFromLanguage("WindowManager", "mnuSwitchTo", mnuSwitchTo->Caption);
mnuMove->Caption = ReadFromLanguage("WindowManager", "mnuMove", mnuMove->Caption);
mnuAlwaysOnTop->Caption = ReadFromLanguage("WindowManager", "mnuAlwaysOnTop", mnuAlwaysOnTop->Caption);
mnuNotAlwaysOnTop->Caption = ReadFromLanguage("WindowManager", "mnuNotAlwaysOnTop", mnuNotAlwaysOnTop->Caption);
mnuHide->Caption = ReadFromLanguage("WindowManager", "mnuHide", mnuHide->Caption);
mnuShow->Caption = ReadFromLanguage("WindowManager", "mnuShow", mnuShow->Caption);
mnuFlash->Caption = ReadFromLanguage("WindowManager", "mnuFlash", mnuFlash->Caption);
mnuRename->Caption = ReadFromLanguage("WindowManager", "mnuRename", mnuRename->Caption);
mnuEndProcess->Caption = ReadFromLanguage("WindowManager", "mnuEndProcess", mnuEndProcess->Caption);
mnuNewTask->Caption = ReadFromLanguage("ClientMain", "mnuNewTask", mnuNewTask->Caption);
cmdNewTask->Caption = mnuNewTask->Caption;
cmdSwitchTo->Caption = mnuSwitchTo->Caption;
cmdEndTask->Caption = mnuEndTask->Caption;
cmdEndProcess->Caption = mnuEndProcess->Caption;

mnuView->Caption = ReadFromLanguage("ServerMain", "mnuView", mnuView->Caption);
mnuReport->Caption = ReadFromLanguage("General", "mnuDetailIcons", mnuReport->Caption);
mnuLargeIcons->Caption = ReadFromLanguage("General", "mnuLargeIcons", mnuLargeIcons->Caption);
mnuSmallIcons->Caption = ReadFromLanguage("General", "mnuSmallIcons", mnuSmallIcons->Caption);
mnuList->Caption = ReadFromLanguage("General", "mnuListIcons", mnuList->Caption);

mnuSetPriority->Caption = ReadFromLanguage("WindowManager", "mnuSetPriority", mnuSetPriority->Caption);
mnuRealtime->Caption = ReadFromLanguage("WindowManager", "mnuRealtime", mnuRealtime->Caption);
mnuHigh->Caption = ReadFromLanguage("WindowManager", "mnuHigh", mnuHigh->Caption);
mnuNormal->Caption = ReadFromLanguage("WindowManager", "mnuNormal", mnuNormal->Caption);
mnuIdle->Caption = ReadFromLanguage("WindowManager", "mnuIdle", mnuIdle->Caption);

tabWindows->Tabs->Strings[0] = ReadFromLanguage("WindowManager", "tabApplications", "Applications");
tabWindows->Tabs->Strings[1] = ReadFromLanguage("WindowManager", "tabProcesses", "Processes");
//tabWindows->Tabs->Strings[2] = ReadFromLanguage("WindowManager", "tabPerformance", "Performance");
}

mnuRefresh->Click();
}
//---------------------------------------------------------------------------

















void __fastcall TfrmTaskManager::chkGetMousePositionClick(
      TObject *Sender)
{
tmrGetMousePosition->Enabled = chkGetMousePosition->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::tmrRefreshTimer(TObject *Sender)
{
this->Cursor = crDefault;
tmrRefresh->Enabled = False;
mnuRefresh->Caption = ReadFromLanguage("General", "Refresh", "&Refresh");
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::lviWindowsEdited(TObject *Sender,
      TListItem *Item, AnsiString &S)
{
frmMain->SendCommand(COMMAND_WINDOW_RENAME, Item->Caption + SEPARATOR_SPLIT + S, this->Tag);

}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::lviProcessMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (lviProcess->SelCount == 0) return; 

if (Button == mbRight) {
                       tagPOINT CursorPos;
                       GetCursorPos(&CursorPos);

                       mnuRealtime->Checked = false;
                       mnuHigh->Checked = false;
                       mnuNormal->Checked = false;
                       mnuIdle->Checked = false;

                       if (lviProcess->Selected->SubItems->Strings[1] == PARAMETER_REALTIME) mnuRealtime->Checked = true;
                       if (lviProcess->Selected->SubItems->Strings[1] == PARAMETER_HIGH) mnuHigh->Checked = true;
                       if (lviProcess->Selected->SubItems->Strings[1] == PARAMETER_NORMAL) mnuNormal->Checked = true;
                       if (lviProcess->Selected->SubItems->Strings[1] == PARAMETER_IDLE) mnuIdle->Checked = true;

                       mnuProcessPopup->Popup(CursorPos.x, CursorPos.y);
                       }
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::SendPriority(const AnsiString sPriority)
{
int w;

for (w = 0; w < lviProcess->Items->Count; ++w)
        {
        if (lviProcess->Items->Item[w]->Selected) frmMain->SendCommand(COMMAND_PROCESS_PRIORITY, lviProcess->Items->Item[w]->SubItems->Strings[0] + SEPARATOR_SPLIT + sPriority, this->Tag);
        }

mnuRefresh->Click();
}

void __fastcall TfrmTaskManager::mnuRealtimeClick(TObject *Sender)
{
SendPriority(PARAMETER_REALTIME);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuHighClick(TObject *Sender)
{
SendPriority(PARAMETER_HIGH);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuNormalClick(TObject *Sender)
{
SendPriority(PARAMETER_NORMAL);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuIdleClick(TObject *Sender)
{
SendPriority(PARAMETER_IDLE);
}
//---------------------------------------------------------------------------


void __fastcall TfrmTaskManager::mnuCloseClick(TObject *Sender)
{
this->Close();
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuRefreshClick(TObject *Sender)
{
lviWindows->Clear();
lviProcess->Clear();

cmdSwitchTo->Enabled = false;
cmdEndTask->Enabled = false;
cmdEndProcess->Enabled = false;

this->Cursor = crAppStart;
tmrRefresh->Enabled = true;
mnuRefresh->Enabled = false;
mnuRefresh->Caption = ReadFromLanguage("General", "Refreshing", "Refreshing...");

if (mnuVisibleWindowsOnly->Checked) {
                                    frmMain->SendCommand(COMMAND_WINDOW_LIST, PARAMETER_VISIBLE, this->Tag);
                                    } else {
                                    frmMain->SendCommand(COMMAND_WINDOW_LIST, PARAMETER_INVISIBLE, this->Tag);
                                    }
//frmMain->SendCommand(COMMAND_PROCESS_LIST, "", this->Tag);
//frmMain->SendCommand(COMMAND_CPU_USAGE, "", this->Tag);
}
//---------------------------------------------------------------------------


void __fastcall TfrmTaskManager::mnuVisibleWindowsOnlyClick(
      TObject *Sender)
{
if (mnuVisibleWindowsOnly->Checked) { mnuVisibleWindowsOnly->Checked = false; } else { mnuVisibleWindowsOnly->Checked = true; }
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::tabWindowsChange(TObject *Sender)
{

grpApplications->Visible = false;
grpProcesses->Visible = false;
grpPerformance->Visible = false;


switch (tabWindows->TabIndex)
{
case 0:
grpApplications->Visible = true;
break;

case 1:
grpProcesses->Visible = true;
break;

//case 2:
//grpPerformance->Visible = true;
//break;
}

}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuEndProcessClick(TObject *Sender)
{
int w;

for (w = 0; w < lviProcess->Items->Count; ++w)
        {
        if (lviProcess->Items->Item[w]->Selected) frmMain->SendCommand(COMMAND_PROCESS_KILL, lviProcess->Items->Item[w]->SubItems->Strings[0], this->Tag);
        }

mnuRefresh->Click();
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuEndTaskClick(TObject *Sender)
{
SendWindowCommand(COMMAND_WINDOW_TERMINATE, "", true);
}
//---------------------------------------------------------------------------


void __fastcall TfrmTaskManager::mnuMaximizeClick(TObject *Sender)
{
SendWindowCommand(COMMAND_WINDOW_MAXIMIZE, "", false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuMinimizeClick(TObject *Sender)
{
SendWindowCommand(COMMAND_WINDOW_MINIMIZE, "", false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuShowClick(TObject *Sender)
{
SendWindowCommand(COMMAND_WINDOW_SHOW, "", false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuHideClick(TObject *Sender)
{
SendWindowCommand(COMMAND_WINDOW_HIDE, "", true);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuSwitchToClick(TObject *Sender)
{
SendWindowCommand(COMMAND_WINDOW_FOCUS, "", false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuFlashClick(TObject *Sender)
{
SendWindowCommand(COMMAND_WINDOW_FLASH, "", false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuFreezeClick(TObject *Sender)
{
SendWindowCommand(COMMAND_WINDOW_FREEZE, "", false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuUnfreezeClick(TObject *Sender)
{
SendWindowCommand(COMMAND_WINDOW_UNFREEZE, "", false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuRenameClick(TObject *Sender)
{
lviWindows->Selected->EditCaption();
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuMoveClick(TObject *Sender)
{
SendWindowCommand(COMMAND_WINDOW_MOVE, SEPARATOR_SINGLE + txtMouseX->Text + SEPARATOR_SINGLE + txtMouseY->Text, false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuAlwaysOnTopClick(TObject *Sender)
{
SendWindowCommand(COMMAND_WINDOW_ALWAYSONTOP, "", false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuNotAlwaysOnTopClick(TObject *Sender)
{
SendWindowCommand(COMMAND_WINDOW_NOTALWAYSONTOP, "", false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::lviWindowsMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (Button == mbRight) {
                       tagPOINT CursorPos;
                       GetCursorPos(&CursorPos);

                       if (lviWindows->SelCount > 0) { mnuWindowsPopup->Popup(CursorPos.x, CursorPos.y); } else { mnuWindowsSinglePopup->Popup(CursorPos.x, CursorPos.y); }
                       }

}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuNewTaskClick(TObject *Sender)
{
TfrmExecute * frmExecuteInst = new TfrmExecute(Application);

if (frmExecuteInst == NULL) return; // Memory allocation error

frmExecuteInst->Tag = this->Tag;
frmExecuteInst->Caption = "[" + frmMain->HandleToHostname(this->Tag) + "] " + DelHK(ReadFromLanguage("ClientMain", "mnuEndTask", mnuEndTask->Caption));
frmExecuteInst->Show();
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::UncheckMenu()
{
mnuLargeIcons->Checked = false;
mnuSmallIcons->Checked = false;
mnuList->Checked = false;
mnuReport->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TfrmTaskManager::mnuLargeIconsClick(TObject *Sender)
{
lviWindows->ViewStyle = vsIcon;
UncheckMenu();
mnuLargeIcons->Checked = true;
}

void __fastcall TfrmTaskManager::mnuSmallIconsClick(TObject *Sender)
{
lviWindows->ViewStyle = vsSmallIcon;
UncheckMenu();
mnuSmallIcons->Checked = true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuListClick(TObject *Sender)
{
lviWindows->ViewStyle = vsList;
UncheckMenu();
mnuList->Checked = true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuReportClick(TObject *Sender)
{
lviWindows->ViewStyle = vsReport;
UncheckMenu();
mnuReport->Checked = true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::mnuSelectAllClick(TObject *Sender)
{
lviProcess->SelectAll();
lviWindows->SelectAll();
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::FormResize(TObject *Sender)
{
tabWindows->Width = this->Width - 25;
tabWindows->Height = this->Height - 78;

grpApplications->Width = tabWindows->Width - 16;
grpApplications->Height = tabWindows->Height - 32;
grpProcesses->Width = grpApplications->Width;
grpProcesses->Height = grpApplications->Height;
grpPerformance->Width = grpApplications->Width;
grpPerformance->Height = grpApplications->Height;

lviWindows->Width = grpApplications->Width - 16;
lviWindows->Height = grpApplications->Height - 55;    //25
lviProcess->Width = lviWindows->Width;
lviProcess->Height = lviWindows->Height;

cmdNewTask->Top = lviWindows->Left + lviWindows->Height + 15;
cmdSwitchTo->Top = cmdNewTask->Top;
cmdEndTask->Top = cmdSwitchTo->Top;

cmdNewTask->Left = (lviWindows->Left + lviWindows->Width) - cmdNewTask->Width;
cmdSwitchTo->Left = cmdNewTask->Left - cmdSwitchTo->Width - 10;
cmdEndTask->Left = cmdSwitchTo->Left - cmdEndTask->Width - 10;

cmdEndProcess->Left = (lviProcess->Left + lviProcess->Width) - cmdEndProcess->Width;
cmdEndProcess->Top = cmdNewTask->Top; 
}
//---------------------------------------------------------------------------



void __fastcall TfrmTaskManager::lviWindowsClick(TObject *Sender)
{
if (lviWindows->SelCount > 0) {
                              cmdEndTask->Enabled = true;
                              cmdSwitchTo->Enabled = true;
                              } else {
                              cmdEndTask->Enabled = false;
                              cmdSwitchTo->Enabled = false;
                              }
}
//---------------------------------------------------------------------------

void __fastcall TfrmTaskManager::lviProcessClick(TObject *Sender)
{
if (lviProcess->SelCount > 0) {
                              cmdEndProcess->Enabled = true;
                              } else {
                              cmdEndProcess->Enabled = false;
                              }
}
//---------------------------------------------------------------------------

