/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


// Copyright (C) 2002  Antti Kirjavainen


//---------------------------------------------------------------------------
#ifndef WindowManagerH
#define WindowManagerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TfrmTaskManager : public TForm
{
__published:	// IDE-managed Components
        TImageList *imgLarge;
        TImageList *imgSmall;
        TTimer *tmrGetMousePosition;
        TGroupBox *grpControl;
        TEdit *txtMouseX;
        TEdit *txtMouseY;
        TCheckBox *chkGetMousePosition;
        TTimer *tmrRefresh;
        TPopupMenu *mnuProcessPopup;
        TMenuItem *mnuEndProcess;
        TMenuItem *N1;
        TMenuItem *mnuSetPriority;
        TMenuItem *mnuRealtime;
        TMenuItem *mnuHigh;
        TMenuItem *mnuNormal;
        TMenuItem *mnuIdle;
        TTabControl *tabWindows;
        TGroupBox *grpApplications;
        TGroupBox *grpPerformance;
        TGroupBox *grpProcesses;
        TListView *lviWindows;
        TListView *lviProcess;
        TMainMenu *mnuMain;
        TMenuItem *mnuFile;
        TMenuItem *mnuRefresh;
        TMenuItem *N2;
        TMenuItem *mnuClose;
        TMenuItem *mnuVisibleWindowsOnly;
        TPopupMenu *mnuWindowsPopup;
        TMenuItem *mnuSwitchTo;
        TMenuItem *N3;
        TMenuItem *mnuMinimize;
        TMenuItem *mnuMaximize;
        TMenuItem *N4;
        TMenuItem *mnuEndTask;
        TMenuItem *mnuHide;
        TMenuItem *mnuShow;
        TMenuItem *mnuFlash;
        TMenuItem *N5;
        TMenuItem *mnuFreeze;
        TMenuItem *mnuUnfreeze;
        TMenuItem *mnuMove;
        TMenuItem *mnuRename;
        TMenuItem *mnuAlwaysOnTop;
        TMenuItem *mnuNotAlwaysOnTop;
        TPopupMenu *mnuWindowsSinglePopup;
        TMenuItem *mnuNewTask;
        TMenuItem *mnuView;
        TMenuItem *mnuLargeIcons;
        TMenuItem *mnuSmallIcons;
        TMenuItem *N6;
        TMenuItem *mnuList;
        TMenuItem *mnuReport;
        TMenuItem *N7;
        TMenuItem *mnuSelectAll;
        TStatusBar *stbStatus;
        TButton *cmdEndTask;
        TButton *cmdSwitchTo;
        TButton *cmdNewTask;
        TButton *cmdEndProcess;
        void __fastcall tmrGetMousePositionTimer(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall chkGetMousePositionClick(TObject *Sender);
        void __fastcall tmrRefreshTimer(TObject *Sender);
        void __fastcall lviWindowsEdited(TObject *Sender, TListItem *Item,
          AnsiString &S);
void __fastcall SendWindowCommand(const AnsiString wCommand, const AnsiString wParams, const bool rRefresh);
        void __fastcall lviProcessMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall mnuRealtimeClick(TObject *Sender);
        void __fastcall mnuHighClick(TObject *Sender);
        void __fastcall mnuNormalClick(TObject *Sender);
        void __fastcall mnuIdleClick(TObject *Sender);
        void __fastcall SendPriority(const AnsiString sPriority);
        void __fastcall mnuCloseClick(TObject *Sender);
        void __fastcall mnuRefreshClick(TObject *Sender);
        void __fastcall mnuVisibleWindowsOnlyClick(TObject *Sender);
        void __fastcall tabWindowsChange(TObject *Sender);
        void __fastcall mnuEndProcessClick(TObject *Sender);
        void __fastcall mnuEndTaskClick(TObject *Sender);
        void __fastcall mnuMaximizeClick(TObject *Sender);
        void __fastcall mnuMinimizeClick(TObject *Sender);
        void __fastcall mnuShowClick(TObject *Sender);
        void __fastcall mnuHideClick(TObject *Sender);
        void __fastcall mnuSwitchToClick(TObject *Sender);
        void __fastcall mnuFlashClick(TObject *Sender);
        void __fastcall mnuFreezeClick(TObject *Sender);
        void __fastcall mnuUnfreezeClick(TObject *Sender);
        void __fastcall mnuRenameClick(TObject *Sender);
        void __fastcall mnuMoveClick(TObject *Sender);
        void __fastcall mnuAlwaysOnTopClick(TObject *Sender);
        void __fastcall mnuNotAlwaysOnTopClick(TObject *Sender);
        void __fastcall lviWindowsMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall mnuNewTaskClick(TObject *Sender);
        void __fastcall mnuLargeIconsClick(TObject *Sender);
        void __fastcall mnuSmallIconsClick(TObject *Sender);
        void __fastcall mnuListClick(TObject *Sender);
        void __fastcall mnuReportClick(TObject *Sender);
        void __fastcall UncheckMenu();
        void __fastcall mnuSelectAllClick(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall lviWindowsClick(TObject *Sender);
        void __fastcall lviProcessClick(TObject *Sender);

private:	// User declarations
public:		// User declarations
        __fastcall TfrmTaskManager(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmTaskManager *frmTaskManager;
//---------------------------------------------------------------------------
#endif
