/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

frmUsers
Part of the Specrem-project.

Server user control.
Copyright (C) 2002  Antti Kirjavainen

*/


//---------------------------------------------------------------------------
#include <vcl.h>
#include "Public.cpp"
#include "Main.h"
#include "..\Shared\Commands.h"
#pragma hdrstop

#include "Users.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmUsers *frmUsers;

//---------------------------------------------------------------------------
__fastcall TfrmUsers::TfrmUsers(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmUsers::mnuCloseClick(TObject *Sender)
{
this->Close();
}
//---------------------------------------------------------------------------
void __fastcall TfrmUsers::FormCreate(TObject *Sender)
{
//cmdRefresh->Click();

if (FileExists(ExtractFilePath(Application->ExeName) + "Language.INI"))
{
cmdRefresh->Caption = ReadFromLanguage("General", "Refreshing", cmdRefresh->Caption);
mnuRefresh->Caption = cmdRefresh->Caption;

mnuView->Caption = ReadFromLanguage("ServerMain", "mnuView", mnuView->Caption);
mnuReport->Caption = ReadFromLanguage("General", "mnuDetailIcons", mnuReport->Caption);
mnuLargeIcons->Caption = ReadFromLanguage("General", "mnuLargeIcons", mnuLargeIcons->Caption);
mnuSmallIcons->Caption = ReadFromLanguage("General", "mnuSmallIcons", mnuSmallIcons->Caption);
mnuList->Caption = ReadFromLanguage("General", "mnuListIcons", mnuList->Caption);

mnuFile->Caption = ReadFromLanguage("General", "mnuFile", mnuFile->Caption);
mnuClose->Caption = ReadFromLanguage("General", "mnuClose", mnuClose->Caption);
mnuKickClient->Caption = ReadFromLanguage("General", "mnuKick", mnuKickClient->Caption);
mnuKickClient2->Caption = mnuKickClient->Caption;
mnuKickAll->Caption = ReadFromLanguage("General", "mnuKickAll", mnuKickAll->Caption);
mnuKickAll2->Caption = mnuKickAll->Caption;
mnuSendMessageToSelectedClients->Caption = ReadFromLanguage("General", "SendMessage", mnuSendMessageToSelectedClients->Caption);
mnuSendMessageToSelectedClients2->Caption = mnuSendMessageToSelectedClients->Caption;

lviUsers->Column[0]->Caption = ReadFromLanguage("ServerMain", "colAddress", "IP address");
lviUsers->Column[1]->Caption = ReadFromLanguage("ServerMain", "colChatNickname", "Chat nickname");
lviUsers->Column[2]->Caption = ReadFromLanguage("ServerMain", "colStatus", "Status");
//lviUsers->Column[3]->Caption = ReadFromLanguage("ServerMain", "colLastAction", "Last action");
}

}
//---------------------------------------------------------------------------

void __fastcall TfrmUsers::mnuKickClientClick(TObject *Sender)
{
int i;

for (i = 0; i < lviUsers->Items->Count; ++i)
        {
        if (lviUsers->Items->Item[i]->Selected) { frmMain->SendCommand(COMMAND_USERS_KICK, lviUsers->Items->Item[i]->Caption, this->Tag); }
        }

cmdRefresh->Click();
}
//---------------------------------------------------------------------------

void __fastcall TfrmUsers::mnuFileClick(TObject *Sender)
{
if (lviUsers->SelCount == 0 || lviUsers->Items->Item[0]->Selected)
                          {
                          mnuKickClient->Enabled = false;
                          mnuSendMessageToSelectedClients->Enabled = false;
                          }
                          else
                          {
                          mnuKickClient->Enabled = true;
                          mnuSendMessageToSelectedClients->Enabled = true;
                          }
}
//---------------------------------------------------------------------------

void __fastcall TfrmUsers::lviUsersMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
tagPOINT curPos;

if (lviUsers->SelCount == 0) return;
if (lviUsers->Items->Item[0]->Selected) {
                                        mnuKickClient2->Enabled = false;
                                        mnuSendMessageToSelectedClients2->Enabled = false;
                                        } else {
                                        mnuKickClient2->Enabled = true;
                                        mnuSendMessageToSelectedClients2->Enabled = true;
                                        }

GetCursorPos(&curPos);
if (Button == mbRight) mnuPopUp->Popup(curPos.x, curPos.y);
}
//---------------------------------------------------------------------------

void __fastcall TfrmUsers::mnuSendMessageToSelectedClientsClick(
      TObject *Sender)
{
int i;
AnsiString msgAsk;

InputQuery(ReadFromLanguage("Msgbox", "msgPrivateMessage", "Send private message"), ReadFromLanguage("Msgbox", "msgPrivateMessage", "Private message:"), msgAsk); 
if (msgAsk.Length() == 0) return;


for (i = 0; i < lviUsers->Items->Count; ++i)
        {
        if (lviUsers->Items->Item[i]->Selected) { frmMain->SendCommand(COMMAND_MESSAGE_USER, lviUsers->Items->Item[i]->Caption + SEPARATOR_SPLIT + msgAsk, this->Tag); }
        }
}
//---------------------------------------------------------------------------

void __fastcall TfrmUsers::mnuKickAllClick(TObject *Sender)
{
frmMain->SendCommand(COMMAND_USERS_KICKALL, "", this->Tag);
cmdRefresh->Click();        
}
//---------------------------------------------------------------------------


void __fastcall TfrmUsers::mnuRefreshClick(TObject *Sender)
{
this->Cursor = crAppStart;
tmrRefresh->Enabled = True;
cmdRefresh->Enabled = False;
cmdRefresh->Caption = ReadFromLanguage("General", "Refreshing", "Refreshing...");
lviUsers->Clear();
frmMain->SendCommand(COMMAND_USERS_LIST, "", this->Tag);
}
//---------------------------------------------------------------------------

void __fastcall TfrmUsers::SetViewStyle(TViewStyle newStyle)
{
mnuLargeIcons->Checked = False;
mnuSmallIcons->Checked = False;
mnuList->Checked = False;
mnuReport->Checked = False;

if (newStyle == vsIcon) mnuLargeIcons->Checked = True;
if (newStyle == vsSmallIcon) mnuSmallIcons->Checked = True;
if (newStyle == vsList) mnuList->Checked = True;
if (newStyle == vsReport) mnuReport->Checked = True;

lviUsers->ViewStyle = newStyle;
}


//---------------------------------------------------------------------------
void __fastcall TfrmUsers::mnuSmallIconsClick(TObject *Sender)
{
SetViewStyle(vsSmallIcon);
}
//---------------------------------------------------------------------------

void __fastcall TfrmUsers::mnuLargeIconsClick(TObject *Sender)
{
SetViewStyle(vsIcon);
}
//---------------------------------------------------------------------------


void __fastcall TfrmUsers::mnuReportClick(TObject *Sender)
{
SetViewStyle(vsReport);
}
//---------------------------------------------------------------------------

void __fastcall TfrmUsers::mnuListClick(TObject *Sender)
{
SetViewStyle(vsList);
}
//---------------------------------------------------------------------------


void __fastcall TfrmUsers::tmrRefreshTimer(TObject *Sender)
{
this->Cursor = crDefault;
tmrRefresh->Enabled = False;
cmdRefresh->Caption = ReadFromLanguage("General", "Refresh", "&Refresh");
}
//---------------------------------------------------------------------------

void __fastcall TfrmUsers::FormResize(TObject *Sender)
{
lviUsers->Width = this->Width - 8;
lviUsers->Height = this->Height - 115;
lblConnectedCount->Width = this->Width - 8;
cmdRefresh->Width = this->Width - 8;
lblConnectedCount->Top = lviUsers->Top + lviUsers->Height + 5;
cmdRefresh->Top = lblConnectedCount->Top + lblConnectedCount->Height + 5;

}
//---------------------------------------------------------------------------

void __fastcall TfrmUsers::lviUsersDblClick(TObject *Sender)
{
mnuSendMessageToSelectedClients->Click();
}
//---------------------------------------------------------------------------

