/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

frmWork
Part of the Specrem-project.

Work list of downloads, uploads + other stuff.
Copyright (C) 2002  Antti Kirjavainen

*/


//---------------------------------------------------------------------------
#include <vcl.h>
#include "Main.h"
#include "Public.cpp"
#pragma hdrstop

#include "Work.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmWork *frmWork;


//---------------------------------------------------------------------------
__fastcall TfrmWork::TfrmWork(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmWork::FormResize(TObject *Sender)
{
lviWork->Width = this->Width - 8;
lviWork->Height = this->Height - 28;
}
//---------------------------------------------------------------------------
void __fastcall TfrmWork::lviWorkMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (lviWork->Items->Count == 0) return;
if (Button != mbRight) return;

tagPOINT CursorPos;
GetCursorPos(&CursorPos);

mnuPopUp->Popup(CursorPos.x, CursorPos.y);
}
//---------------------------------------------------------------------------

void __fastcall TfrmWork::FormCreate(TObject *Sender)
{
mnuClear->Caption = ReadFromLanguage("General", "cmdClear", mnuClear->Caption);
mnuExecuteThis->Caption = ReadFromLanguage("ClientMain", "mnuExecuteThis", mnuExecuteThis->Caption);
mnuRemoveFromList->Caption = ReadFromLanguage("ClientMain", "mnuRemoveFromList", mnuRemoveFromList->Caption);
mnuStop->Caption = ReadFromLanguage("ClientMain", "cmdStop", mnuStop->Caption);
lviWork->Column[1]->Caption = ReadFromLanguage("General", "Local", "Local");
lviWork->Column[1]->Caption = ReadFromLanguage("General", "Remote", "Remote");
lviWork->Column[2]->Caption = ReadFromLanguage("General", "Action", "Action");
}
//---------------------------------------------------------------------------

void __fastcall TfrmWork::lviWorkDblClick(TObject *Sender)
{
mnuExecuteThis->Click();
}
//---------------------------------------------------------------------------


void __fastcall TfrmWork::FormCloseQuery(TObject *Sender, bool &CanClose)
{
this->Hide();
CanClose = False;
}
//---------------------------------------------------------------------------


void __fastcall TfrmWork::ProcessNextCommand(const unsigned short int iIndex)
{
AnsiString NextCommand;
AnsiString RemoteFile;
AnsiString LocalFile;
unsigned int ComputerHandle;
unsigned int ResumeSize;
//short int i;

if (lviWork->Items->Count == 0) return;

// Prevent running multiple instances of this void with a simple int:
//if (this->Tag > 0) return;
if (iIndex >= lviWork->Items->Count) return;

//ShowMessage(this->Tag);
this->Tag = 1;


//i = -1;
//i = 0;

//do
//{
//i++;
//if (i >= lviWork->Items->Count) break;
//if (lviWork->Items->Item[i]->SubItems->Text == "") break;
if (lviWork->Items->Item[iIndex]->SubItems->Text == "") return;

ComputerHandle = StrToIntDef(lviWork->Items->Item[iIndex]->SubItems->Strings[4], 0);
if (ComputerHandle == 0) {
                         lviWork->Items->Delete(iIndex);
                         return; }
//if (frmMain->IsReserved(ComputerHandle)) continue;
if (frmMain->IsReserved(ComputerHandle)) return;

LocalFile = lviWork->Items->Item[iIndex]->Caption;
RemoteFile = lviWork->Items->Item[iIndex]->SubItems->Strings[0];
NextCommand = lviWork->Items->Item[iIndex]->SubItems->Strings[1];
ResumeSize = StrToIntDef(lviWork->Items->Item[iIndex]->SubItems->Strings[3], 0);


//if (NextCommand == COMMAND_FILE_DOWNLOAD)
if (LocalFile != "-") frmMain->SetFilename(LocalFile, ComputerHandle);



if (frmMain->OpenFile(LocalFile, ComputerHandle, ResumeSize, true) == -1) {
                                                                          //continue;
                                                                          return;
                                                                          }
lviWork->Items->Delete(iIndex);
frmMain->SendCommand(NextCommand, RemoteFile, ComputerHandle);

//}
//while (i < lviWork->Items->Count);

//this->Tag = 0;
}

void __fastcall TfrmWork::mnuExecuteThisClick(TObject *Sender)
{
ProcessNextCommand(lviWork->Selected->Index);
}
//---------------------------------------------------------------------------


void __fastcall TfrmWork::mnuRemoveFromListClick(TObject *Sender)
{
unsigned short int i;

for (i = 0; i < lviWork->Items->Count; ++i)
         {
         if (lviWork->Items->Item[i]->Selected) lviWork->Items->Delete(i);
         }

}
//---------------------------------------------------------------------------

void __fastcall TfrmWork::mnuClearClick(TObject *Sender)
{
mnuStop->Click();
lviWork->Clear();
}
//---------------------------------------------------------------------------


void __fastcall TfrmWork::lviWorkInsert(TObject *Sender, TListItem *Item)
{
//frmMain->SwitchIcon(frmWork->lviWork, 2, 0, COMMAND_FILE_DOWNLOAD);
//frmMain->SwitchIcon(frmWork->lviWork, 2, 1, COMMAND_FILE_UPLOAD);
ProcessNextCommand(0);
}
//---------------------------------------------------------------------------

