/********************************************************************************************
Stdredirect, v 0.0.1 Alpha/Beta/Gamma :)
1999 by Tair Abdurman
testing on NT 4.0 workstation
********************************************************************************************/


/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

CMDHook.cpp
Part of the Specrem-project.

Function to hook CMD.EXE and run commands.
Originally written by Tair Abdurman, but considerable
amounts of changes and new code written by Farid Bengrid.

Copyright (C) 1999  Tair Abdurman
Copyright (C) 2002  Antti Kirjavainen
Copyright (C) 2002  Farid Bengrid

*/


#include <windows.h>
//#include <stdio.h>
//#include <string.h>

//#define MAX_BUFFER_LENGTH 512
#define MAX_BUFFER_LENGTH 128000

char * CMDExec(char * strCommandToExecute);


char * CMDExec(char * CommandToExecute)
	{
	//Standart structures to lunch process
	static char sBuffer[MAX_BUFFER_LENGTH];

	char EXECUTABLE_PATH[200];
	PROCESS_INFORMATION pi;
	SECURITY_ATTRIBUTES saProcess,saThread;
	STARTUPINFO si;

	//Output, Input and Error pipe handles
	HANDLE hOutputRead, hOutputWrite;
	HANDLE hInputRead, hInputWrite;
	HANDLE hErrorRead, hErrorWrite;

	//worker variables
	DWORD nBufferRead,nTotalBytesAvail,nBytesLeft;
	char lpszBuffer[MAX_BUFFER_LENGTH];
	BOOL bRet,bCommandScan,bExitLoop;

	ZeroMemory(&saProcess,sizeof(saProcess));
	ZeroMemory(&saThread,sizeof(saThread));
	ZeroMemory(&si,sizeof(si));

	saProcess.nLength=sizeof(SECURITY_ATTRIBUTES);
	saThread.nLength =sizeof(SECURITY_ATTRIBUTES);

	saThread.bInheritHandle=saProcess.bInheritHandle=TRUE;
	saThread.lpSecurityDescriptor=saProcess.lpSecurityDescriptor=NULL;

	si.cb = sizeof(si);
	si.dwFlags=STARTF_USESTDHANDLES;

	GetSystemDirectory(EXECUTABLE_PATH, sizeof(EXECUTABLE_PATH));
        strcat(EXECUTABLE_PATH, "\\CMD.EXE");

	if((bRet = CreatePipe(&hInputRead,&hInputWrite, &saProcess, 0))==0)
		goto EndFct;

	if((bRet = CreatePipe(&hOutputRead,&hOutputWrite, &saProcess, 0))==0)
		goto EndFct;

	if((bRet = CreatePipe(&hErrorRead,&hErrorWrite, &saProcess, 0))==0)
		goto EndFct;
	
	si.hStdError=hErrorWrite;
	si.hStdOutput=hOutputWrite;
	si.hStdInput=hInputRead;

	if((bRet=CreateProcess(NULL,EXECUTABLE_PATH,&saProcess,&saThread,TRUE,DETACHED_PROCESS,NULL,NULL,&si,&pi))==0)
		goto EndFct;

	//Clean the buffer
	memset(lpszBuffer,0x00,MAX_BUFFER_LENGTH);

	//show microsoft's welcome
	nBufferRead=0;
	nTotalBytesAvail=0;
	nBytesLeft=0;
	bCommandScan=FALSE;
	bExitLoop=FALSE;

	while(!bExitLoop)
		{
		//SCAN COMMAND
		//send the command
		if (bCommandScan)
			{
			//Clean the buffer
			memset(lpszBuffer,0x00,MAX_BUFFER_LENGTH);
			
			//Copy the command to execute in it
			memcpy(lpszBuffer,CommandToExecute,strlen(CommandToExecute));

			//Send the command
			WriteFile(hInputWrite,lpszBuffer,strlen(lpszBuffer),&nBufferRead,NULL);
			
			//bCommandScan=FALSE;
			bExitLoop=TRUE;
			}
		
		//wait for response
		nBufferRead=0;
		nTotalBytesAvail=0;
		nBytesLeft=0;
		memset(sBuffer,0x00,MAX_BUFFER_LENGTH);

		//GET RESPONSE
		do
			{
			//Check if there are data to be read;
			if((bRet = PeekNamedPipe(hOutputRead,NULL,NULL,NULL,&nTotalBytesAvail,NULL))==0)
				break;
			
			//is there some data to read ?
			if (nTotalBytesAvail>0)
				{
				//yes so get it
				memset(lpszBuffer,0x00,MAX_BUFFER_LENGTH);
				if((bRet=ReadFile(hOutputRead, lpszBuffer, nTotalBytesAvail, &nBufferRead, NULL))==0)
					break;

				//Copy the result in the local buffer
				memcpy(sBuffer+strlen(sBuffer),lpszBuffer,strlen(lpszBuffer));
				}
			} while(sBuffer[strlen(sBuffer) - 1]!='>' && lpszBuffer[strlen(lpszBuffer) - 1] != '>');
		bCommandScan = TRUE;
		}

EndFct:
	CloseHandle(hInputRead);
	CloseHandle(hInputWrite);
	CloseHandle(hOutputRead);
	CloseHandle(hOutputWrite);
	CloseHandle(hErrorRead);
	CloseHandle(hErrorWrite);
	TerminateThread(pi.hThread, 0);
	CloseHandle(pi.hThread);
	CloseHandle(pi.hProcess);

	//MessageBox(NULL, sBuffer, "", 0);
	
	return sBuffer;
	}

