/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

StreamCompress.cpp
Part of the Specrem-project.


FileStream JPEG-compression and comparison.
Also checks if the screen has changed.

The actual screen capture is in another unit,
check the #includes.

Copyright (C) 2002  Antti Kirjavainen

*/


//---------------------------------------------------------------------------
#include <vcl.h>
#include <Jpeg.hpp>
//---------------------------------------------------------------------------
//#include ""




bool StreamChanged(TMemoryStream * newStream1, TMemoryStream * newStream2);
int CompressStream(TMemoryStream * newStream, const unsigned short int cQuality, const bool cGrayScale);






bool StreamChanged(TMemoryStream * newStream1, TMemoryStream * newStream2)
// Stream compare, has the picture changed?
{
char strComp1[1024];
char strComp2[1024];


try
{
if (newStream1->Size != newStream2->Size) return true;
if (newStream1->Size <= 1024) return true;
if (newStream2->Size <= 1024) return true;


newStream1->Position = 0;
newStream1->ReadBuffer(strComp1, 1024);
newStream2->Position = 0;
newStream2->ReadBuffer(strComp2, 1024);


if (AnsiString(strComp1) != AnsiString(strComp2)) return true;

}
catch (Exception &exception)
{
return true;
}


return false;
}

int CompressStream(TMemoryStream * newStream, const unsigned short int cQuality, const bool cGrayScale)
// JPEG compression for a BMP in stream:
{
TJPEGImage * jpgImage = new TJPEGImage;
Graphics::TBitmap * bmpImage = new Graphics::TBitmap();


if (jpgImage == NULL) return -1;
if (bmpImage == NULL) return -1;


try
{
newStream->Position = 0;
bmpImage->LoadFromStream(newStream);

jpgImage->Grayscale = cGrayScale;
jpgImage->CompressionQuality = cQuality;
jpgImage->ProgressiveEncoding = true;
jpgImage->Assign(bmpImage);

newStream->Clear();
newStream->Position = 0;
jpgImage->SaveToStream(newStream);
newStream->Position = 0;
}
catch (Exception &exception)
{
return -1;
}


delete bmpImage;
delete jpgImage;

return 0;
}


 