/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

Class TUserInfo
Part of the Specrem-project.

Copyright (C) 2002  Antti Kirjavainen

*/


class TUserInfo
{
        public:
        TUserInfo() { usAccessLevel = 0; usHandle = 0; usBuffer = ""; usBufferCommand = ""; usEncryptionKey = NULL; usNickname = ""; usAddress = ""; usPath = "C:\\"; usScreenView = false; usFloodAmount = 0; usFilePos = 0; usFileSize = 0; usFileOp = 0; usFileHandle = NULL; screenPart = NULL; usRouter = NULL; usFlood = NULL; usLogin = NULL; usKeyboardListen = NULL; usMouseListen = NULL; usPing = NULL; }
        ~TUserInfo() { if (usRouter != NULL) usRouter->Free(); if (usFlood != NULL) usFlood->Free(); if (usPing != NULL) usPing->Free(); if (usLogin != NULL) usLogin->Free(); if (usMouseListen != NULL) usMouseListen->Free(); if (usKeyboardListen != NULL) usKeyboardListen->Free(); if (screenPart != NULL) screenPart->Free(); if (usFileHandle != NULL) FileClose(usFileHandle); }
        void ClearCommand() {usCommand = "";}
        AnsiString usCommand; // The command will be saved here, until the ENTER-key is pressed.
        unsigned short int usFloodAmount; // Tracks the amount of data a guest is sending.
        bool usScreenView; // Is the client using screen viewing with screen spy or full control?
        bool UsingWebcam; // Client using webcam?

        unsigned int usFileOp; // File operation, 0 = nothing, 1 = download, 2 = upload.
        __int64 usFilePos; // When sending file, save the file position here.
        unsigned int usFileSize; // When sending file, save the file size here.
        unsigned int usFileHandle; // When sending file, save the file handle here.
        TMemoryStream * screenPart; // For screen viewing.

        TClientSocket * usRouter; // Router socket pointer
        TTimer * usFlood; // Flood timer pointer
        TTimer * usLogin; // Login timeout
        TTimer * usKeyboardListen; // Timer for sending pressed keys list
        TTimer * usMouseListen; // Timer for sending mouse listen info
        TTimer * usPing; // Ping timeout

        void SetAccess(unsigned short int aLevel) {if (aLevel <= 2) usAccessLevel = aLevel;}
        void SetAddress(AnsiString aAddress) {usAddress = aAddress;}
        void SetEncryptionKey(AnsiString aKey) {usEncryptionKey = aKey;}
        void SetHandle(unsigned int aHandle) {usHandle = aHandle;}
        void SetLastMousePos(const unsigned short int newX, const unsigned short int newY) {curX = newX; curY = newY;}
        void SetNick(AnsiString aNick) {usNickname = aNick;}
        void SetPath(AnsiString aPath) {usPath = aPath;}

        int GetAccess() const {return usAccessLevel;}
        AnsiString GetAddress() const {return usAddress;}
        AnsiString GetKey() const {return usEncryptionKey;}
        int GetHandle() const {return usHandle;}
        AnsiString GetNick() const {return usNickname;}
        AnsiString GetPath() const {return usPath;}
        AnsiString usBuffer; // Buffer for list sending
        AnsiString usBufferCommand; // Command for buffer data
        bool MousePosChanged(const unsigned short int newX, const unsigned short int newY) const {if (curX != newX) return true; if (curY != newY) return true; return false;}

        int CommandLength() {return usCommand.Length();}

        private:
        unsigned short int usAccessLevel;  // 0 = not logged in, 1 = restricted address, 2 = admin
        unsigned int usHandle; // Socket->SocketHandle
        AnsiString usEncryptionKey; // The random key for this client, NULL = Telnet-connection, no encryption
        AnsiString usNickname; // Chat-nickname
        AnsiString usAddress; // Socket->RemoteAddress
        AnsiString usPath; // Current path for File manager
        unsigned short int curX;
        unsigned short int curY;
};
