/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

WebCam.cpp
Part of the Specrem-project.

Server webcam control.
Copyright (C) 2002  Antti Kirjavainen

*/


//---------------------------------------------------------------------------
#include <vcl.h>
#include <windows.h>
#include <vfw.h>


//---------------------------------------------------------------------------
LRESULT WINAPI SelCapDrvProc(HWND, UINT, WPARAM, LPARAM);
//---------------------------------------------------------------------------
HWND hwndMain; // main window handle
HWND hwndVideo; // video capture window
HWND hwndSelCapDrvDlg; // Select the capture driver dialog
HWND hwndSelCapDrvDlg_LBox; // list box for select capture driver dialog
CAPDRIVERCAPS CapDrvCaps; // driver capabilities
//---------------------------------------------------------------------------
int CapturePicture(AnsiString FileName);
void OpenCamera(TScrollBox * scBox);
void CloseCamera();
//---------------------------------------------------------------------------


LRESULT CALLBACK SelCapDrvProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{

	switch(msg)
	{
		case WM_INITDIALOG:
                        return true;

		case WM_COMMAND:

			switch ( wParam )
			{

                        case 0:
                        int sel = 0;
                        SendMessage(hwndSelCapDrvDlg_LBox, LB_GETSELITEMS, 1, sel);
                        SendMessage(hwndVideo, WM_CAP_DRIVER_CONNECT, sel, 0L);
                        SendMessage(hwndSelCapDrvDlg, WM_CLOSE, 0, 0);
                        SendMessage(hwndVideo, WM_CAP_DRIVER_GET_CAPS, sizeof(CAPDRIVERCAPS), (LONG) (LPVOID) &CapDrvCaps);
                        capPreviewRate(hwndVideo, 50);
                        capPreview(hwndVideo, true);
			}

			return true;

		case WM_CLOSE:
			DestroyWindow(hwndSelCapDrvDlg);
			return true;
	}

return (0L);
}
//---------------------------------------------------------------------------
void OpenCamera(TScrollBox * scBox)
{
hwndVideo = capCreateCaptureWindow((LPSTR) "Capture Window", WS_CHILD | WS_VISIBLE, 2, 2, 250, 250, (HWND) scBox->Handle, (int) 1);
SelCapDrvProc(hwndMain, WM_COMMAND, 0, 0);
//SelCapDrvProc(hwndMain, WM_COMMAND, SELCAPDRVDLG_BUTTON, 0);

    CAPSTATUS CapStatus;
    capGetStatus(hwndVideo, &CapStatus, sizeof(CapStatus));
    SetWindowPos(hwndVideo, NULL, 0, 0, CapStatus.uiImageWidth, CapStatus.uiImageHeight, SWP_NOZORDER | SWP_NOMOVE);
}
//---------------------------------------------------------------------------

void CloseCamera()
{
capPreview(hwndVideo, false);
capDriverDisconnect(hwndVideo);
DestroyWindow(hwndVideo);
hwndVideo = NULL;
}

int CapturePicture(AnsiString FileName)
{
// VFW requires the file to be saved to disk... this program does not...
// But unfortunately VFW wins this time, can't get the picture out any other way :(
try
{
if (FileExists(FileName)) DeleteFile(FileName);

if (capFileSetCaptureFile(hwndVideo, FileName.c_str())) { } else { return -1; }

if (FileExists(FileName)) DeleteFile(FileName);
if (capFileSaveDIB(hwndVideo, FileName.c_str())) { return 0; } else { return -1; }

}
catch (Exception &exception)
{
return -1;
}

}
//---------------------------------------------------------------------------

