//  Copyright (C) 2002 RealVNC Ltd. All Rights Reserved.
//  Copyright (C) 1999 AT&T Laboratories Cambridge. All Rights Reserved.
//
//  This file is part of the VNC system.
//
//  The VNC system is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
//  USA.
//
// If the source code for the program is not available from the place from
// which you received this file, check http://www.realvnc.com/ or contact
// the authors on info@realvnc.com for information on obtaining it.

// vncKeymap.cpp

// This code originally just mapped between X keysyms and local Windows
// virtual keycodes.  Now it actually does the local-end simulation of
// key presses, to keep this messy code on one place!


/*

vKey.cpp
The definitions taken from VNC.

Copyright (C) 1999  AT&T Laboratories Cambridge.
Copyright (C) 2002  Antti Kirjavainen

*/


#include <stdio.h>

// Define the special keys:

#define XKEY_ALT_LEFT		0xFFE9
#define XKEY_ALT_RIGHT		0xFFEA
#define XKEY_CTRL_LEFT	        0xFFE3
#define XKEY_CTRL_RIGHT	0xFFE4
#define XKEY_CAPSLOCK	        0xFFE5
#define XKEY_SHIFT_LEFT		0xFFE1
#define XKEY_SHIFT_RIGHT	0xFFE2
#define XKEY_SHIFTLOCK	        0xFFE6
#define XKEY_META_LEFT		0xFFE7
#define XKEY_META_RIGHT		0xFFE8

#define XKEY_SPACE            0x020

#define XKEY_DEAD_ACUTE       0xFE51
#define XKEY_DEAD_GRAVE       0xFE50
#define XKEY_DEAD_TILDE       0xFE53
#define XKEY_DEAD_CIRCUMFLEX  0xFE52

#define XKEY_PAUSE		    0xFF13
#define XKEY_SCROLLLOCK		0xFF14
#define XKEY_SYSREQ		    0xFF15
#define XKEY_ESC		    0xFF1B
#define XKEY_BACKSPACE	      0xFF08
#define XKEY_TAB	      0xFF09
#define XKEY_LINEF	      0xFF0A
#define XKEY_CLEAR		    0xFF0B
#define XKEY_ENTER		    0xFF0D

#define XKEY_HOME			0xFF50
#define XKEY_LEFT			0xFF51
#define XKEY_UP			0xFF52
#define XKEY_RIGHT		0xFF53
#define XKEY_DOWN			0xFF54
#define XKEY_PAGEUP		0xFF55
#define XKEY_PAGEDOWN	0xFF56
#define XKEY_END			0xFF57
#define XKEY_BEGIN		0xFF58
#define XKEY_DEL		    0xFFFF

#define XKEY_EXECUTE		0xFF62
#define XKEY_INSERT		0xFF63
#define XKEY_SELECT		0xFF60
#define XKEY_PRINT		0xFF61

#define XKEY_BREAK		0xFF6B
#define XKEY_NUMLOCK		0xFF7F
#define XKEY_CANCEL		0xFF69
#define XKEY_HELP			0xFF6A

#define XKEY_KP_ENTER		0xFF8D	
#define XKEY_KP_SPACE		0xFF80
#define XKEY_KP_TAB		0xFF89

#define XKEY_KP_HOME		0XFF95
#define XKEY_KP_LEFT		0XFF96
#define XKEY_KP_UP		0XFF97
#define XKEY_KP_RIGHT		0XFF98
#define XKEY_KP_DOWN		0XFF99
#define XKEY_KP_PRIOR		0XFF9A
#define XKEY_KP_PAGEUP	0XFF9A
#define XKEY_KP_NEXT		0XFF9B
#define XKEY_KP_PAGEDOWN	0XFF9B
#define XKEY_KP_END		0XFF9C
#define XKEY_KP_BEGIN		0XFF9D
#define XKEY_KP_INSERT	0XFF9E
#define XKEY_KP_DELETE	0XFF9F
#define XKEY_KP_EQUAL		0XFFBD
#define XKEY_KP_MULTIPLY	0XFFAA
#define XKEY_KP_ADD		0XFFAB
#define XKEY_KP_SEPARATOR	0XFFAC
#define XKEY_KP_SUBTRACT	0XFFAD
#define XKEY_KP_DECIMAL	0XFFAE
#define XKEY_KP_DIVIDE	0XFFAF
#define XKEY_KP_F1		0xFF91
#define XKEY_KP_F2		0xFF92
#define XKEY_KP_F3		0xFF93
#define XKEY_KP_F4		0xFF94

#define XKEY_KP_0			0xFFB0
#define XKEY_KP_1			0xFFB1
#define XKEY_KP_2			0xFFB2
#define XKEY_KP_3			0xFFB3
#define XKEY_KP_4			0xFFB4
#define XKEY_KP_5			0xFFB5
#define XKEY_KP_6			0xFFB6
#define XKEY_KP_7			0xFFB7
#define XKEY_KP_8			0xFFB8
#define XKEY_KP_9			0xFFB9

#define XKEY_F1			0xFFBE
#define XKEY_F2			0xFFBF
#define XKEY_F3			0xFFC0
#define XKEY_F4			0xFFC1
#define XKEY_F5			0xFFC2
#define XKEY_F6			0xFFC3
#define XKEY_F7			0xFFC4
#define XKEY_F8			0xFFC5
#define XKEY_F9			0xFFC6
#define XKEY_F10			0xFFC7
#define XKEY_F11			0xFFC8
#define XKEY_F12			0xFFC9
#define XKEY_F13			0xFFCA
#define XKEY_F14			0xFFCB
#define XKEY_F15			0xFFCC
#define XKEY_F16			0xFFCD
#define XKEY_F17			0xFFCE
#define XKEY_F18			0xFFCF
#define XKEY_F19			0xFFD0
#define XKEY_F20			0xFFD1
#define XKEY_F21			0xFFD2
#define XKEY_F22			0xFFD3
#define XKEY_F23			0xFFD4
#define XKEY_F24			0xFFD5


typedef struct keyMap_struct {
	UINT wincode;
	UINT Xcode;
} kMap;


// Define the constants to use the special keys:
const kMap keymap[] = {
            {'`',		XKEY_DEAD_GRAVE},
            {'',		XKEY_DEAD_ACUTE},
            {'~',		XKEY_DEAD_TILDE},
            {'^',		XKEY_DEAD_CIRCUMFLEX},
            {VK_BACK,		XKEY_BACKSPACE},
            {VK_TAB,		XKEY_TAB},
            {VK_CLEAR,		XKEY_CLEAR},
            {VK_RETURN,		XKEY_ENTER},
            {VK_LSHIFT,		XKEY_SHIFT_LEFT},
            {VK_RSHIFT,		XKEY_SHIFT_RIGHT},
            {VK_LCONTROL,	XKEY_CTRL_LEFT},
            {VK_RCONTROL,	XKEY_CTRL_RIGHT},
            {VK_LMENU,		XKEY_ALT_LEFT},
            {VK_RMENU,		XKEY_ALT_RIGHT},
            {VK_PAUSE,		XKEY_PAUSE},
            {VK_CAPITAL,	XKEY_CAPSLOCK},
            {VK_ESCAPE,		XKEY_ESC},
            {VK_SPACE,		XKEY_SPACE},
            {VK_PRIOR,		XKEY_PAGEUP},
            {VK_NEXT,		XKEY_PAGEDOWN},
            {VK_END,		XKEY_END},
            {VK_HOME,		XKEY_HOME},
            {VK_LEFT,		XKEY_LEFT},
            {VK_UP,		XKEY_UP},
            {VK_RIGHT,		XKEY_RIGHT},
            {VK_DOWN,		XKEY_DOWN},
            {VK_SELECT,		XKEY_SELECT},
            {VK_EXECUTE,	XKEY_EXECUTE},
            {VK_SNAPSHOT,	XKEY_PRINT},
            {VK_INSERT,		XKEY_INSERT},
            {VK_DELETE,		XKEY_DEL},
            {VK_HELP,		XKEY_HELP},
            {VK_NUMPAD0,	XKEY_KP_0},
            {VK_NUMPAD1,	XKEY_KP_1},
            {VK_NUMPAD2,	XKEY_KP_2},
            {VK_NUMPAD3,	XKEY_KP_3},
            {VK_NUMPAD4,	XKEY_KP_4},
            {VK_NUMPAD5,	XKEY_KP_5},
            {VK_NUMPAD6,	XKEY_KP_6},
            {VK_NUMPAD7,	XKEY_KP_7},
            {VK_NUMPAD8,	XKEY_KP_8},
            {VK_NUMPAD9,	XKEY_KP_9},
            {VK_SPACE,		XKEY_KP_SPACE},
            {VK_TAB,		XKEY_KP_TAB},
            {VK_RETURN,		XKEY_KP_ENTER},
            {VK_F1,		XKEY_KP_F1},
            {VK_F2,		XKEY_KP_F2},
            {VK_F3,		XKEY_KP_F3},
            {VK_F4,		XKEY_KP_F4},
            {VK_HOME,		XKEY_KP_HOME},
            {VK_LEFT,		XKEY_KP_LEFT},
            {VK_UP,		XKEY_KP_UP},
            {VK_RIGHT,		XKEY_KP_RIGHT},
            {VK_DOWN,		XKEY_KP_DOWN},
            {VK_PRIOR,		XKEY_KP_PRIOR},
            {VK_PRIOR,		XKEY_KP_PAGEUP},
            {VK_NEXT,		XKEY_KP_NEXT},
            {VK_NEXT,		XKEY_KP_PAGEDOWN},
            {VK_END,		XKEY_KP_END},
            {VK_INSERT,		XKEY_KP_INSERT},
            {VK_DELETE,		XKEY_KP_DELETE},
            {VK_MULTIPLY,	XKEY_KP_MULTIPLY},
            {VK_ADD,		XKEY_KP_ADD},
            {VK_SEPARATOR,	XKEY_KP_SEPARATOR},
            {VK_SUBTRACT,	XKEY_KP_SUBTRACT},
            {VK_DECIMAL,	XKEY_KP_DECIMAL},
            {VK_DIVIDE,		XKEY_KP_DIVIDE},
            {VK_F1,		XKEY_F1},
            {VK_F2,		XKEY_F2},
            {VK_F3,		XKEY_F3},
            {VK_F4,		XKEY_F4},
            {VK_F5,		XKEY_F5},
            {VK_F6,		XKEY_F6},
            {VK_F7,		XKEY_F7},
            {VK_F8,		XKEY_F8},
            {VK_F9,		XKEY_F9},
            {VK_F10,		XKEY_F10},
            {VK_F11,		XKEY_F11},
            {VK_F12,		XKEY_F12},
            {VK_F13,		XKEY_F13},
            {VK_F14,		XKEY_F14},
            {VK_F15,		XKEY_F15},
            {VK_F16,		XKEY_F16},
            {VK_F17,		XKEY_F17},
            {VK_F18,		XKEY_F18},
            {VK_F19,		XKEY_F19},
            {VK_F20,		XKEY_F20},
            {VK_F21,		XKEY_F21},
            {VK_F22,		XKEY_F22},
            {VK_F23,		XKEY_F23},
            {VK_F24,		XKEY_F24},
            {VK_NUMLOCK,	XKEY_NUMLOCK},
            {VK_SCROLL,		XKEY_SCROLLLOCK}};

void KeybdEvent(byte kCode, DWORD kFlags)
// And the usual Windows system call to virtually press the keys:
{
keybd_event(kCode, MapVirtualKey(kCode, 0), kFlags, 0);
}

void PressString(char * strKeys)
// Press every char in a string:
{
unsigned short int k;
char HexFormat[3];
byte HexNum;

for (k = 0; k < 4; ++k)
        {
        sprintf(HexFormat, "%02X", strKeys[k]);
        HexNum = StrToInt(HexFormat);
        KeybdEvent(HexNum, 1 ? 0 : KEYEVENTF_KEYUP);
        }
}

void PressShift(byte ShiftKey, bool ShiftDown)
// Press Shift-keys, like Ctrl, Alt, etc.
{
//bool keystate = (GetAsyncKeyState(ShiftKey) & 0x8000) != 0;
//if ((keystate && ShiftDown) || ((!keystate) && (!ShiftDown))) return;
KeybdEvent(ShiftKey, ShiftDown ? 0 : KEYEVENTF_KEYUP);
//keystate = (GetAsyncKeyState(ShiftKey) & 0x8000) != 0;
}



