/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

DriveHandle.cpp
Part of the Specrem-project.

Get drive list and open CD-ROM.
Copyright (C) 2002  Antti Kirjavainen

*/


//---------------------------------------------------------------------------
//#include <vcl.h>
#include <mmsystem.h>


AnsiString GetDrives();
bool IsDriveCDROM(const AnsiString strDrive);
void OpenCloseCD(const bool Open, const AnsiString strDrive);




//---------------------------------------------------------------------------
AnsiString GetDrives()
{
// Get all drives to a string and check if they are fixed or removable:
DWORD ld = GetLogicalDrives();
unsigned short int i;
AnsiString tmpStr;
AnsiString drv;

try
{
for (i = 0; i < 26; i++)
       {
       if ((ld & (1 << i)) != 0)
                                {
                                drv = String(char('A' + i)) + ":";
                                if (IsDriveCDROM(drv)) { drv += SEPARATOR_SPLIT + "Removable"; } else { drv += SEPARATOR_SPLIT + "Fixed"; }
				tmpStr += drv + SEPARATOR_SINGLE;
                                }
       }


}
catch (Exception &exception)
{
return NULL;
}


return tmpStr;
}

   
//---------------------------------------------------------------------------
void OpenCloseCD(const bool Open, const AnsiString strDrive)
{
// Open/Close a CD-drive:
AnsiString s;

try
{

s = "open " + strDrive + " type cdaudio alias cd";

mciSendString(s.c_str(), 0, 0, 0);
s = "set cd door " + String(Open ? "open" : "closed");
mciSendString(s.c_str(), 0, 0, 0);
mciSendString("close cd", 0, 0, 0);

}
catch (Exception &exception)
{
}

}


//---------------------------------------------------------------------------
bool IsDriveCDROM(const AnsiString strDrive)
{
// Removable or fixed?
if (GetDriveType(strDrive.c_str()) == DRIVE_CDROM) { return true; } else { return false; }
}
//---------------------------------------------------------------------------

AnsiString OneDirUp(AnsiString sPath)
{
unsigned short int i;
unsigned short int LastPos;
AnsiString newPath;

if (sPath.Length() < 4) return sPath;
if (sPath.SubString(sPath.Length(), 1) == "\\") sPath = sPath.SubString(1, sPath.Length() - 1);

for (i = 1; i <= sPath.Length(); ++i)
         {
         if (sPath.SubString(i, 1) == "\\") LastPos = i;
         }

newPath = sPath.SubString(1, LastPos);
return newPath;
}

