/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

GetFileInfo.cpp
Part of the Specrem-project.

File properties.
Copyright (C) 2002  Farid Bengrid

*/


//---------------------------------------------------------------------------
#include <vcl.h>
#include <windows.h>
#include <stdio.h>
#include <string>
using namespace std;
#include "..\Shared\FolderList.hpp"
//#include "..\Shared\Commands.h"
//---------------------------------------------------------------------------
string getFileInfoStr(FileInfo * ptrFileInfo);
string getFileInfoStrWide(FileInfo * ptrFileInfo);
string GetFolderList(const AnsiString sPath, const bool Wide);
//---------------------------------------------------------------------------


string GetFolderList(const AnsiString sPath, const bool Wide)
{
unsigned long index;
string msg;
FolderList dirList;
FileInfo * ptrFileInfo;
AnsiString SEPARATOR_SINGLE = "\n\r";

	if (dirList.storePathContent(string(sPath.c_str())) != 0) {
                                                                  return "-1";
                                                                  }
        msg = "";

	for (index=0;index<dirList.getNumberOfFolders();index++)
		{
		ptrFileInfo = (FileInfo *)dirList.getFolderInfo(index);

		if (Wide) { msg += getFileInfoStrWide(ptrFileInfo); } else { msg += getFileInfoStr(ptrFileInfo); }
		msg += string(SEPARATOR_SINGLE.c_str());
		}


	for (index=0;index<dirList.getNumberOfFiles();index++)
		{
		ptrFileInfo = (FileInfo *)dirList.getFileInfo(index);

		if (Wide) { msg += getFileInfoStrWide(ptrFileInfo); } else { msg += getFileInfoStr(ptrFileInfo); }
		msg += string(SEPARATOR_SINGLE.c_str());
		}
        
//MessageBox(NULL, msg.c_str(), "", 0);
return msg;
}

string getFileInfoStr(FileInfo * ptrFileInfo)
	{
	string msg;
        unsigned short int l;
	structFileInfo_Date fiDate;
	char Buffer[40];
        AnsiString SpaceSep = "     ";
        AnsiString SpaceS = " ";
        AnsiString sLen;

	msg = "";

	msg+=(ptrFileInfo->isDirectory() ?"D":"-");
	msg+=(ptrFileInfo->isAnArchive() ?"A":"-");
	msg+=(ptrFileInfo->isCompressed()?"C":"-");
	msg+=(ptrFileInfo->isEncrypted() ?"E":"-");
	msg+=(ptrFileInfo->isHidden()    ?"H":"-");
	msg+=(ptrFileInfo->isOffline()   ?"O":"-");
	msg+=(ptrFileInfo->isReadOnly()  ?"R":"-");
	msg+=(ptrFileInfo->isSystem()    ?"S":"-");
	msg+=(ptrFileInfo->isTemporary() ?"T":"-");
	
	fiDate=ptrFileInfo->getDateLastWrite();
	msg += string(SpaceSep.c_str()) + ptrFileInfo->dateToString(fiDate);
	msg += ", " + ptrFileInfo->timeToString(fiDate);

	sprintf(Buffer, "%I64Ld", ptrFileInfo->getFileSize().QuadPart);

        sLen = AnsiString(ptrFileInfo->getFileSize().QuadPart);
	msg += string(SpaceSep.c_str());
	msg += Buffer;

        for (l = 1; l <= 10; ++l)
                 {
                 if (sLen.Length() < l) msg += string(SpaceS.c_str());
                 }

	msg += string(SpaceSep.c_str()) + ptrFileInfo->getWideFilename();

	return msg;
}

string getFileInfoStrWide(FileInfo * ptrFileInfo)
	{
	string attr = "";
	string msg = "";
	structFileInfo_Date fiDate;
	char Buffer[40];
        AnsiString SEPARATOR_SPLIT = "|";

	attr+=(ptrFileInfo->isDirectory() ?"D":"-");
	attr+=(ptrFileInfo->isAnArchive() ?"A":"-");
	attr+=(ptrFileInfo->isCompressed()?"C":"-");
	attr+=(ptrFileInfo->isEncrypted() ?"E":"-");
	attr+=(ptrFileInfo->isHidden()    ?"H":"-");
	attr+=(ptrFileInfo->isOffline()   ?"O":"-");
	attr+=(ptrFileInfo->isReadOnly()  ?"R":"-");
	attr+=(ptrFileInfo->isSystem()    ?"S":"-");
	attr+=(ptrFileInfo->isTemporary() ?"T":"-");
	
	msg += ptrFileInfo->getWideFilename();

	sprintf(Buffer, "%I64Ld", ptrFileInfo->getFileSize().QuadPart);

	msg += string(SEPARATOR_SPLIT.c_str()) + Buffer;

	fiDate = ptrFileInfo->getDateLastWrite();
	msg += string(SEPARATOR_SPLIT.c_str()) + ptrFileInfo->dateToString(fiDate);
	msg += ", " + ptrFileInfo->timeToString(fiDate);

	msg += string(SEPARATOR_SPLIT.c_str()) + attr;


	fiDate = ptrFileInfo->getDateCreate();
	msg += string(SEPARATOR_SPLIT.c_str()) + ptrFileInfo->dateToString(fiDate);
	msg += ", " + ptrFileInfo->timeToString(fiDate);

	fiDate = ptrFileInfo->getDateLastAccessed();
	msg += string(SEPARATOR_SPLIT.c_str()) + ptrFileInfo->dateToString(fiDate);
	msg += ", " + ptrFileInfo->timeToString(fiDate);

	return msg;
}


 