/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

frmServerOptions
Part of the Specrem-project.

Server settings remotely and locally.
Shared between client and configuration program.

Copyright (C) 2002  Antti Kirjavainen

*/


//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ServerOptions.h"
#include "ServerOpt.cpp"
#include "..\Shared\Settings.cpp"
//#include "..\Shared\strHandle.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmServerOptions *frmServerOptions;

AnsiString CreateList(TfrmServerOptions * frmOpt);

//---------------------------------------------------------------------------
__fastcall TfrmServerOptions::TfrmServerOptions(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmServerOptions::cmdCancelClick(TObject *Sender)
{
this->Close();
}
//---------------------------------------------------------------------------
void __fastcall TfrmServerOptions::cmdShowAdministratorPasswordClick(
      TObject *Sender)
{
grpAdministratorPassword->Visible = True;
cmdShowAdministratorPassword->Enabled = False;
cmdOK->Enabled = false;
cmdApply->Enabled = false;
txtAdministratorPassword->SetFocus();
txtAdministratorPassword->SelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TfrmServerOptions::cmdShowGuestPasswordClick(
      TObject *Sender)
{
grpGuestPassword->Visible = True;
cmdShowGuestPassword->Enabled = False;
cmdOK->Enabled = false;
cmdApply->Enabled = false;
txtGuestPassword->SetFocus();
txtGuestPassword->SelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TfrmServerOptions::cmdChangeAdministratorPasswordClick(
      TObject *Sender)
{
AnsiString tmpStr;
AnsiString tmpStr2;

if (txtAdministratorPassword->Text == "")
                                        {
                                        return;
                                        }
if (txtAdministratorPassword->Text != txtRetypeAdministratorPassword->Text)
                                        {
                                        tmpStr = ReadFromLanguage("Errors", "PasswordMatch", "Passwords don't match") + "!";
                                        tmpStr2 = ReadFromLanguage("General", "Error", "Error");
                                        MessageBox(NULL, tmpStr.c_str(), tmpStr2.c_str(), 0);
                                        return;
                                        }

grpAdministratorPassword->Visible = False;
cmdShowAdministratorPassword->Enabled = True;
cmdOK->Enabled = true;
cmdApply->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TfrmServerOptions::cmdChangeGuestPasswordClick(
      TObject *Sender)
{
AnsiString tmpStr;
AnsiString tmpStr2;

if (txtAdministratorPassword->Text != txtRetypeAdministratorPassword->Text)
                                        {
                                        tmpStr = ReadFromLanguage("Errors", "PasswordMatch", "Passwords don't match") + "!";
                                        tmpStr2 = ReadFromLanguage("General", "Error", "Error");
                                        MessageBox(NULL, tmpStr.c_str(), tmpStr2.c_str(), 0);
                                        return;
                                        }

grpGuestPassword->Visible = False;
cmdShowGuestPassword->Enabled = True;
cmdOK->Enabled = true;
cmdApply->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TfrmServerOptions::txtAdministratorPasswordKeyPress(
      TObject *Sender, char &Key)
{
if (Key == 13)
             {
             txtRetypeAdministratorPassword->SetFocus();
             txtRetypeAdministratorPassword->SelectAll();
             }
}
//---------------------------------------------------------------------------
void __fastcall TfrmServerOptions::txtRetypeAdministratorPasswordKeyPress(
      TObject *Sender, char &Key)
{
if (Key == 13) cmdChangeAdministratorPassword->Click();        
}
//---------------------------------------------------------------------------
void __fastcall TfrmServerOptions::txtGuestPasswordKeyPress(
      TObject *Sender, char &Key)
{
if (Key == 13)
             {
             txtRetypeGuestPassword->SetFocus();
             txtRetypeGuestPassword->SelectAll();
             }
}
//---------------------------------------------------------------------------
void __fastcall TfrmServerOptions::txtRetypeGuestPasswordKeyPress(
      TObject *Sender, char &Key)
{
if (Key == 13) cmdChangeGuestPassword->Click();
}
//---------------------------------------------------------------------------

void __fastcall TfrmServerOptions::tabOptionsChange(TObject *Sender)
{

grpSecurity->Visible = false;
grpOptions->Visible = false;
grpAcceptReject->Visible = false;


switch (tabOptions->TabIndex)
{
case 0:
grpSecurity->Visible = true;
break;

case 1:
grpOptions->Visible = true;
break;

case 2:
grpAcceptReject->Visible = true;
break;
}

}
//---------------------------------------------------------------------------

void __fastcall TfrmServerOptions::chkAcceptClick(TObject *Sender)
{
txtAccept->Enabled = chkAccept->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmServerOptions::chkRejectClick(TObject *Sender)
{
txtReject->Enabled = chkReject->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmServerOptions::optServerClick(TObject *Sender)
{
txtBind->Enabled = optServer->Checked;
txtPort->Enabled = optServer->Checked;
txtCallbackAddress->Enabled = optCallback->Checked;
txtCallbackPort->Enabled = optCallback->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmServerOptions::optCallbackClick(TObject *Sender)
{
txtCallbackAddress->Enabled = optCallback->Checked;
txtCallbackPort->Enabled = optCallback->Checked;
txtBind->Enabled = optServer->Checked;
txtPort->Enabled = optServer->Checked;
}
//---------------------------------------------------------------------------

AnsiString CreateList(TfrmServerOptions * frmOpt)
{
TStringList * strOptions = new TStringList;
AnsiString retString;

strOptions->Add("[Options]");
strOptions->Add("TrayIcon=" + ConvertBooleanToWord(frmOpt->chkTrayIcon->Checked));
strOptions->Add("Telnet=" + ConvertBooleanToWord(frmOpt->chkTelnet->Checked));
strOptions->Add("Ping=" + ConvertBooleanToWord(frmOpt->chkPing->Checked));
strOptions->Add("GuestAccess=" + ConvertBooleanToWord(frmOpt->chkGuestAccess->Checked));
strOptions->Add("Accept=" + ConvertBooleanToWord(frmOpt->chkAccept->Checked));
strOptions->Add("Reject=" + ConvertBooleanToWord(frmOpt->chkReject->Checked));
strOptions->Add("Server=" + ConvertBooleanToWord(frmOpt->optServer->Checked));
strOptions->Add("Callback=" + ConvertBooleanToWord(frmOpt->optCallback->Checked));
strOptions->Add("Bind=" + frmOpt->txtBind->Text);
strOptions->Add("Port=" + frmOpt->txtPort->Text);
strOptions->Add("FilePort=" + frmOpt->txtFilePort->Text);
strOptions->Add("CallbackAddress=" + frmOpt->txtCallbackAddress->Text);
strOptions->Add("CallbackPort=" + frmOpt->txtCallbackPort->Text);
strOptions->Add("MaxTotal=" + frmOpt->txtTotal->Text);
strOptions->Add("MaxAddr=" + frmOpt->txtAddress->Text);

strOptions->Add("");
strOptions->Add("[Passwords]");
strOptions->Add("Administrator=" + frmOpt->txtAdministratorPassword->Text);
strOptions->Add("Guest=" + frmOpt->txtGuestPassword->Text);

strOptions->Add("");
strOptions->Add("[Accept]");
strOptions->Add(frmOpt->txtAccept->Text);

strOptions->Add("");
strOptions->Add("[Reject]");
strOptions->Add(frmOpt->txtReject->Text);

strOptions->Add("");
strOptions->Add("[END]");


retString = strOptions->Text;
strOptions->Free();

return retString;
}

void __fastcall TfrmServerOptions::cmdOKClick(TObject *Sender)
{
if (txtAdministratorPassword->Text == "")
                                        {
                                        tabOptions->TabIndex = 0;
                                        grpOptions->Visible = false;
                                        grpAcceptReject->Visible = false;
                                        grpSecurity->Visible = true;
                                        if (!grpAdministratorPassword->Visible) cmdShowAdministratorPassword->Click();
                                        return;
                                        }


// Are we running client or SConfig? Let's find out by the tag-value:
//if (this->Tag == 0) ShellExecute(Application->Handle, "open", "NET.EXE", "START SServer7", "", SW_SHOW);


if (SaveOptions(CreateList(this), this) == 0) this->Close();
}
//---------------------------------------------------------------------------

void __fastcall TfrmServerOptions::cmdApplyClick(TObject *Sender)
{
if (txtAdministratorPassword->Text == "")
                                        {
                                        tabOptions->TabIndex = 0;
                                        grpOptions->Visible = false;
                                        grpAcceptReject->Visible = false;
                                        grpSecurity->Visible = true;
                                        if (!grpAdministratorPassword->Visible) cmdShowAdministratorPassword->Click();
                                        return;
                                        }
SaveOptions(CreateList(this), this);
}
//---------------------------------------------------------------------------

void __fastcall TfrmServerOptions::txtTotalKeyPress(TObject *Sender,
      char &Key)
{
AnsiString strKey;

strKey = IntToStr(Key);
if (strKey == 8) return;
if (strKey < 48 || strKey > 57) Key = 0;
}
//---------------------------------------------------------------------------


void __fastcall TfrmServerOptions::txtAcceptKeyPress(TObject *Sender,
      char &Key)
{
AnsiString strKey;

strKey = IntToStr(Key);
if (strKey == 42) return; // .-mark
if (strKey == 46) return; // *-mark
if (strKey == 63) return; // ?-mark

if (strKey == 8) return; // BackSpace
if (strKey == 13) return; // ENTER
if (strKey < 48 || strKey > 57) Key = 0; // Is it in the number range, 48 - 57 (0 - 9)?
}
//---------------------------------------------------------------------------

void __fastcall TfrmServerOptions::ReadSettings(TMemo * txtSet)
{
chkTrayIcon->Checked = ConvertWordToBoolean(ReadSetting("Options", "TrayIcon", "Yes", txtSet));
chkGuestAccess->Checked = ConvertWordToBoolean(ReadSetting("Options", "GuestAccess", "No", txtSet));
chkTelnet->Checked = ConvertWordToBoolean(ReadSetting("Options", "Telnet", "Yes", txtSet));
chkPing->Checked = ConvertWordToBoolean(ReadSetting("Options", "Ping", "No", txtSet));
optCallback->Checked = ConvertWordToBoolean(ReadSetting("Options", "Callback", "No", txtSet));
optServer->Checked = ConvertWordToBoolean(ReadSetting("Options", "Server", "Yes", txtSet));
chkAccept->Checked = ConvertWordToBoolean(ReadSetting("Options", "Accept", "No", txtSet));
chkReject->Checked = ConvertWordToBoolean(ReadSetting("Options", "Reject", "No", txtSet));
txtBind->Text = ReadSetting("Options", "Bind", "", txtSet);
txtCallbackAddress->Text = ReadSetting("Options", "CallbackAddress", "",txtSet);
txtPort->Text = ReadSetting("Options", "Port", "1187", txtSet);
txtCallbackPort->Text = ReadSetting("Options", "CallbackPort", "1187", txtSet);
txtTotal->Text = ReadSetting("Options", "MaxTotal", "20", txtSet);
txtFilePort->Text = ReadSetting("Options", "FilePort", "4339", txtSet);
txtAddress->Text = ReadSetting("Options", "MaxAddr", "3", txtSet);

txtAdministratorPassword->Text = ReadSetting("Passwords", "Administrator", "", txtSet);
txtRetypeAdministratorPassword->Text = txtAdministratorPassword->Text;
txtGuestPassword->Text = ReadSetting("Passwords", "Guest", "", txtSet);
txtRetypeGuestPassword->Text = txtGuestPassword->Text;

txtAccept->Text = ReadSetting("Accept", "", "", txtSet);
txtReject->Text = ReadSetting("Reject", "", "", txtSet);
}

void __fastcall TfrmServerOptions::FormCreate(TObject *Sender)
{

cmdOK->Caption = ReadFromLanguage("General", "cmdOK", cmdOK->Caption);
cmdCancel->Caption = ReadFromLanguage("General", "cmdCancel", cmdCancel->Caption);
cmdApply->Caption = ReadFromLanguage("General", "cmdApply", cmdApply->Caption);
tabOptions->Tabs->Strings[0] = DelHK(ReadFromLanguage("ClientMain", "mnuHostSecurity", "Security"));
tabOptions->Tabs->Strings[1] = ReadFromLanguage("ServerMain", "mnuOptions", "Options");
tabOptions->Tabs->Strings[2] = ReadFromLanguage("HostSecurity", "mnuAcceptReject", "Accept/Reject");
grpAdministratorPassword->Caption = ReadFromLanguage("HostSecurity", "fraAdminPassword", grpAdministratorPassword->Caption);
grpGuestPassword->Caption = ReadFromLanguage("HostSecurity", "fraGuestPassword", grpGuestPassword->Caption);
cmdChangeAdministratorPassword->Caption = ReadFromLanguage("HostSecurity", "cmdChangeAdmin", cmdChangeAdministratorPassword->Caption);
cmdChangeGuestPassword->Caption = ReadFromLanguage("HostSecurity", "cmdChangeGuest", cmdChangeGuestPassword->Caption);
cmdShowAdministratorPassword->Caption = cmdChangeAdministratorPassword->Caption;
cmdShowGuestPassword->Caption = cmdChangeGuestPassword->Caption;
chkTrayIcon->Caption = ReadFromLanguage("HostOptions", "chkTrayIcon", chkTrayIcon->Caption);
chkGuestAccess->Caption = ReadFromLanguage("HostSecurity", "chkGuestAccess", chkGuestAccess->Caption);
chkTelnet->Caption = ReadFromLanguage("HostSecurity", "chkTelnet", chkTelnet->Caption);
chkPing->Caption = ReadFromLanguage("HostOptions", "chkPing", chkPing->Caption);
optServer->Caption = ReadFromLanguage("General", "Server", "Server");
optCallback->Caption = ReadFromLanguage("ServerMain", "mnuCallback", optCallback->Caption);
lblPort->Caption = ReadFromLanguage("General", "lblPort", "Port:");
lblCallbackPort->Caption = lblPort->Caption;
lblFilePort->Caption = ReadFromLanguage("HostOptions", "FilePort", lblFilePort->Caption);

//lblTotal->Caption = ReadFromLanguage("HostOptions", "lblMaxConnections", lblTotal->Caption);
lblTotal->Caption = ReadFromLanguage("HostOptions", "lblTotal", lblTotal->Caption);
lblAddress->Caption = ReadFromLanguage("HostOptions", "lblAddress", lblAddress->Caption);
chkAccept->Caption = ReadFromLanguage("HostOptions", "chkAccept", chkAccept->Caption);
chkReject->Caption = ReadFromLanguage("HostOptions", "chkReject", chkReject->Caption);


}
//---------------------------------------------------------------------------

void __fastcall TfrmServerOptions::ApplicationEvents1Exception(
      TObject *Sender, Exception *E)
{
// Silence access violation messages...        
}
//---------------------------------------------------------------------------

