/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


// Copyright (C) 2002  Antti Kirjavainen


//---------------------------------------------------------------------------
#ifndef ServerOptionsH
#define ServerOptionsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <AppEvnts.hpp>
//---------------------------------------------------------------------------
class TfrmServerOptions : public TForm
{
__published:	// IDE-managed Components
        TTabControl *tabOptions;
        TButton *cmdCancel;
        TButton *cmdOK;
        TGroupBox *grpSecurity;
        TButton *cmdShowAdministratorPassword;
        TButton *cmdShowGuestPassword;
        TGroupBox *grpAdministratorPassword;
        TEdit *txtAdministratorPassword;
        TButton *cmdChangeAdministratorPassword;
        TEdit *txtRetypeAdministratorPassword;
        TGroupBox *grpGuestPassword;
        TEdit *txtGuestPassword;
        TButton *cmdChangeGuestPassword;
        TEdit *txtRetypeGuestPassword;
        TGroupBox *grpOptions;
        TGroupBox *grpAcceptReject;
        TLabel *lblMaxConnections;
        TLabel *lblTotal;
        TLabel *lblAddress;
        TCheckBox *chkAccept;
        TMemo *txtAccept;
        TCheckBox *chkReject;
        TMemo *txtReject;
        TEdit *txtTotal;
        TEdit *txtAddress;
        TCheckBox *chkTrayIcon;
        TCheckBox *chkTelnet;
        TRadioButton *optServer;
        TRadioButton *optCallback;
        TEdit *txtBind;
        TEdit *txtPort;
        TEdit *txtCallbackAddress;
        TEdit *txtCallbackPort;
        TLabel *lblPort;
        TLabel *lblCallbackPort;
        TCheckBox *chkGuestAccess;
        TButton *cmdApply;
        TMemo *txtTemp;
        TApplicationEvents *ApplicationEvents1;
        TEdit *txtFilePort;
        TLabel *lblFilePort;
        TCheckBox *chkPing;
        void __fastcall cmdCancelClick(TObject *Sender);
        void __fastcall cmdShowAdministratorPasswordClick(TObject *Sender);
        void __fastcall cmdShowGuestPasswordClick(TObject *Sender);
        void __fastcall cmdChangeAdministratorPasswordClick(
          TObject *Sender);
        void __fastcall cmdChangeGuestPasswordClick(TObject *Sender);
        void __fastcall txtAdministratorPasswordKeyPress(TObject *Sender,
          char &Key);
        void __fastcall txtRetypeAdministratorPasswordKeyPress(
          TObject *Sender, char &Key);
        void __fastcall txtGuestPasswordKeyPress(TObject *Sender,
          char &Key);
        void __fastcall txtRetypeGuestPasswordKeyPress(TObject *Sender,
          char &Key);
        void __fastcall tabOptionsChange(TObject *Sender);
        void __fastcall chkAcceptClick(TObject *Sender);
        void __fastcall chkRejectClick(TObject *Sender);
        void __fastcall optServerClick(TObject *Sender);
        void __fastcall optCallbackClick(TObject *Sender);
        void __fastcall cmdOKClick(TObject *Sender);
        void __fastcall cmdApplyClick(TObject *Sender);
        void __fastcall txtTotalKeyPress(TObject *Sender, char &Key);
        void __fastcall txtAcceptKeyPress(TObject *Sender, char &Key);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall ReadSettings(TMemo * txtSet);
        void __fastcall ApplicationEvents1Exception(TObject *Sender,
          Exception *E);
private:	// User declarations
public:		// User declarations
        __fastcall TfrmServerOptions(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmServerOptions *frmServerOptions;
//---------------------------------------------------------------------------
#endif
