/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

Settings.cpp
Part of the Specrem-project.

Code to read server settings.
Copyright (C) 2002  Antti Kirjavainen

*/


//---------------------------------------------------------------------------
#include <vcl.h>
//---------------------------------------------------------------------------
bool ConvertWordToBoolean(const AnsiString sWord)
{
if (sWord == "Yes") return true;
return false; 
}
//---------------------------------------------------------------------------
AnsiString ConvertBooleanToWord(const bool sBool)
{
if (sBool) return "Yes";
return "No";
}
//---------------------------------------------------------------------------
AnsiString ReadSetting(const AnsiString sSection, const AnsiString sKey, const AnsiString sDefault, TMemo * tTemp)
{
unsigned short int i;
bool SectionFound;
AnsiString tmpStr;
unsigned short int iPos;
unsigned short int iPos2;
unsigned short int iLen;

try
{
if (sSection == "Accept" || sSection == "Reject")
                        {
                        iPos = AnsiPos("[" + sSection + "]", tTemp->Lines->Text);
                        if (iPos <= 0) return "";

                        iLen = sSection.Length() + 4;
                        tmpStr = tTemp->Lines->Text.SubString(iPos + iLen, tTemp->Lines->Text.Length() - iPos - iLen);
                        iPos2 = AnsiPos("[", tmpStr) - 3;
                        if (iPos2 == 0) iPos2 = tmpStr.Length();
                        tmpStr = tmpStr.SubString(1, iPos2);
                        return tmpStr;
                        }


for (i = 0; i < tTemp->Lines->Count; ++i)
         {
         if (tTemp->Lines->Strings[i].AnsiPos("[")  > 0) SectionFound = false;
         if (tTemp->Lines->Strings[i] == "[" + sSection + "]") SectionFound = true;
         if (tTemp->Lines->Strings[i].SubString(1, sKey.Length())  == sKey && SectionFound)
                                                                                                                {
                                                                                                                return tTemp->Lines->Strings[i].SubString(sKey.Length() + 2, tTemp->Lines->Strings[i].Length() - sKey.Length() - 1);  
                                                                                                                }
         }
}
catch (Exception &exception)
{
        return "";
}


return sDefault;
}
//---------------------------------------------------------------------------


