/*****************************************************************************
*
*    Specrem Pro - Remote Controlling Software
*    Copyright (C) 2002  Specrem Group
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*****************************************************************************/


/*

Commands.h
Part of the Specrem-project.
Shared between Client and Server.

Full Specrem protocol declared here.
Copyright (C) 2002  Antti Kirjavainen

*/


//---------------------------------------------------------------------------
#ifndef CommandsH
#define CommandsH
//---------------------------------------------------------------------------
#endif

const AnsiString VERSION = "7.00 Alpha 1";

const AnsiString SEPARATOR_COMMAND = " ";
const AnsiString SEPARATOR_SINGLE = "\n\r";
const AnsiString SEPARATOR_SPLIT = "|";
const AnsiString SEPARATOR_END = "\r\n";

const AnsiString COMMAND_CHAT = "CHAT";
const AnsiString COMMAND_CMD = "CMD";
const AnsiString COMMAND_CPU_USAGE = "CPU";
const AnsiString COMMAND_DISABLE_CONTROL = "DISABLECTRL";
const AnsiString COMMAND_ENABLE_CONTROL = "ENABLECTRL";
const AnsiString COMMAND_EXIT = "EXIT";
const AnsiString COMMAND_ENCRYPTION_KEY = "ENC";
const AnsiString COMMAND_ERROR = "ERROR:";
const AnsiString COMMAND_HELP = "?";
const AnsiString COMMAND_HOST_INFORMATION = "HOSTINFO";
const AnsiString COMMAND_HOST_VERSION = "VER";
const AnsiString COMMAND_KEYBOARDLISTEN_START = "LISTENKEYS";
const AnsiString COMMAND_KEYBOARDLISTEN_STOP = "STOPKEYLISTEN";
const AnsiString COMMAND_MESSAGE = "MSG";
const AnsiString COMMAND_MESSAGE_USER = "MSGUSER";
const AnsiString COMMAND_MOUSELISTEN_START = "LISTENMOUSE";
const AnsiString COMMAND_MOUSELISTEN_STOP = "STOPMOUSELISTEN";
const AnsiString COMMAND_NICK = "NICK";
const AnsiString COMMAND_OK = "OK";
const AnsiString COMMAND_OPENCD = "OPENCD";
const AnsiString COMMAND_CLOSECD = "CLOSECD";
const AnsiString COMMAND_PASSWORD = "PASSWORD:";
const AnsiString COMMAND_PING = "PING";
const AnsiString COMMAND_READY = "R";
const AnsiString COMMAND_ROUTER = "CONNECT";
const AnsiString COMMAND_SCREENSHOT = "SCREENSHOT";
const AnsiString COMMAND_SERVER_OPTIONS = "VIEWOPTIONS";
const AnsiString COMMAND_TEXT = "TEXT";
const AnsiString COMMAND_WEBCAMSHOT = "WEBCAMSHOT";

const AnsiString COMMAND_SCREEN_PART = "SCREENXY";
const AnsiString COMMAND_SCREEN_VIEW = "VIEWSCREEN";

const AnsiString COMMAND_USERS_BAN = "BAN";
const AnsiString COMMAND_USERS_BANS = "BANS";
const AnsiString COMMAND_USERS_CLEARBANS = "CLEARBANS";
const AnsiString COMMAND_USERS_KICK = "KICK";
const AnsiString COMMAND_USERS_KICKALL = "KICKALL";
const AnsiString COMMAND_USERS_LIST = "USERS";
const AnsiString COMMAND_USERS_UNBAN = "UNBAN";

const AnsiString COMMAND_FILE_COPY = "COPY";
const AnsiString COMMAND_FILE_DELETE = "DEL";
const AnsiString COMMAND_FILE_DOWNLOAD = "GET";
const AnsiString COMMAND_FILE_EXECUTE = "EXEC";
const AnsiString COMMAND_FILE_FIND = "FIND";
const AnsiString COMMAND_FILE_LIST = "DIR";
const AnsiString COMMAND_FILE_LIST_WIDE = "DIRW";
const AnsiString COMMAND_FILE_DRIVELIST = "DRIVES";
const AnsiString COMMAND_FILE_MOVE = "MOVE";
const AnsiString COMMAND_FILE_OK = "FILEOK";
const AnsiString COMMAND_FILE_PRINT = "PRINT";
const AnsiString COMMAND_FILE_RENAME = "REN";
const AnsiString COMMAND_FILE_UPLOAD = "PUT";
const AnsiString COMMAND_FOLDER_CHANGEDIR = "CD";
const AnsiString COMMAND_FOLDER_CREATE = "MD";
const AnsiString COMMAND_FOLDER_DELETE = "DELTREE";
const AnsiString COMMAND_FOLDER_OK = "CDOK";
const AnsiString COMMAND_TRANSFER_STOP = "ABOR";

const AnsiString COMMAND_SHUTDOWN_DELAY = "DELAY";
const AnsiString COMMAND_SHUTDOWN_LOCK = "LOCK";
const AnsiString COMMAND_SHUTDOWN_LOGOFF = "LOGOFF";
const AnsiString COMMAND_SHUTDOWN_REBOOT = "REBOOT";
const AnsiString COMMAND_SHUTDOWN_SHUTDOWN = "SHUTDOWN";
const AnsiString COMMAND_SHUTDOWN_FORCE = "FSHUTDOWN";
const AnsiString COMMAND_SHUTDOWN_MONITOR = "MONITOR";
const AnsiString COMMAND_SHUTDOWN_SCREENSAVER = "SAVER";
const AnsiString COMMAND_SHUTDOWN_SERVER_CLOSE = "CLOSESERVER";
const AnsiString COMMAND_SHUTDOWN_SERVER_RESTART = "RESTARTSERVER";
const AnsiString COMMAND_SHUTDOWN_STOP = "STOPSHUTDOWN";

const AnsiString COMMAND_REMOTE_MOUSE_MOVE = "#";
const AnsiString COMMAND_REMOTE_MOUSE_DOWN = "!";
const AnsiString COMMAND_REMOTE_MOUSE_UP = "@";
const AnsiString COMMAND_REMOTE_MOUSE_DBLCLICK = "%";

const AnsiString COMMAND_REMOTE_KEYBOARD_PRESS = "K";
const AnsiString COMMAND_REMOTE_KEYBOARD_SPECIAL = "KS";

const AnsiString COMMAND_PROCESS_KILL = "KILL";
const AnsiString COMMAND_PROCESS_LIST = "PROCS";
const AnsiString COMMAND_PROCESS_PRIORITY = "PRIOR";

const AnsiString COMMAND_WINDOW_ALWAYSONTOP = "ONTOP";
const AnsiString COMMAND_WINDOW_FLASH = "FLASH";
const AnsiString COMMAND_WINDOW_FOCUS = "FOCUS";
const AnsiString COMMAND_WINDOW_FREEZE = "FREEZE";
const AnsiString COMMAND_WINDOW_HIDE = "HIDE";
const AnsiString COMMAND_WINDOW_LIST = "WINDOWS";
const AnsiString COMMAND_WINDOW_MAXIMIZE = "MAX";
const AnsiString COMMAND_WINDOW_MINIMIZE = "MIN";
const AnsiString COMMAND_WINDOW_MOVE = "MOVEWIN";
const AnsiString COMMAND_WINDOW_NOTALWAYSONTOP = "NOTONTOP";
const AnsiString COMMAND_WINDOW_RENAME = "RENWIN";
const AnsiString COMMAND_WINDOW_SHOW = "SHOW";
const AnsiString COMMAND_WINDOW_TERMINATE = "CLOSE";
const AnsiString COMMAND_WINDOW_UNFREEZE = "UNFREEZE";

const AnsiString PARAMETER_INVISIBLE = "INV";
const AnsiString PARAMETER_MAXIMIZED = "MAX";
const AnsiString PARAMETER_MINIMIZED = "MIN";
const AnsiString PARAMETER_VISIBLE = "VIS";
const AnsiString PARAMETER_START = "START";
const AnsiString PARAMETER_STOP = "STOP";
const AnsiString PARAMETER_LEFT = "1";
const AnsiString PARAMETER_MIDDLE = "2";
const AnsiString PARAMETER_RIGHT = "3";
const AnsiString PARAMETER_REALTIME = "REALTIME";
const AnsiString PARAMETER_HIGH = "HIGH";
const AnsiString PARAMETER_NORMAL = "NORMAL";
const AnsiString PARAMETER_IDLE = "IDLE";

const AnsiString PARAMETER_INVALID_COMMAND = "Invalid command. Enter ? for help.";
const AnsiString PARAMETER_MISSING_PARAMETER = "Required parameter missing, enter ? for help.";
const AnsiString PARAMETER_PASSWORD_ACCEPTED = "Logged in.";


