Attribute VB_Name = "NICAddress"
'*****************************************************************************
'
'    Specrem Pro - Remote Controlling Software
'    Copyright (C) 2002  Specrem Group
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
'****************************************************************************/



'NICAddress
'Part of the Specrem-project.

'Module to read network information from the system.

'Copyright (C) 2000  ???
'



Option Explicit

Private Const NCBNAMSZ As Long = 16

Private Type NET_CONTROL_BLOCK  'NCB
   ncb_command    As Byte
   ncb_retcode    As Byte
   ncb_lsn        As Byte
   ncb_num        As Byte
   ncb_buffer     As Long
   ncb_length     As Integer
   ncb_callname   As String * NCBNAMSZ
   ncb_name       As String * NCBNAMSZ
   ncb_rto        As Byte
   ncb_sto        As Byte
   ncb_post       As Long
   ncb_lana_num   As Byte
   ncb_cmd_cplt   As Byte
   ncb_reserve(9) As Byte ' Reserved, must be 0
   ncb_event      As Long
End Type

Private Type ADAPTER_STATUS
   adapter_address(5) As Byte
   rev_major         As Byte
   reserved0         As Byte
   adapter_type      As Byte
   rev_minor         As Byte
   duration          As Integer
   frmr_recv         As Integer
   frmr_xmit         As Integer
   iframe_recv_err   As Integer
   xmit_aborts       As Integer
   xmit_success      As Long
   recv_success      As Long
   iframe_xmit_err   As Integer
   recv_buff_unavail As Integer
   t1_timeouts       As Integer
   ti_timeouts       As Integer
   Reserved1         As Long
   free_ncbs         As Integer
   max_cfg_ncbs      As Integer
   max_ncbs          As Integer
   xmit_buf_unavail  As Integer
   max_dgram_size    As Integer
   pending_sess      As Integer
   max_cfg_sess      As Integer
   max_sess          As Integer
   max_sess_pkt_size As Integer
   name_count        As Integer
End Type
   
Private Type NAME_BUFFER
   name        As String * NCBNAMSZ
   name_num    As Integer
   name_flags  As Integer
End Type

Private Type ASTAT
   adapt          As ADAPTER_STATUS
   NameBuff(30)   As NAME_BUFFER
End Type

Public Declare Function Netbios Lib "netapi32.dll" _
   (pncb As NET_CONTROL_BLOCK) As Byte
     
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
   (hpvDest As Any, ByVal _
    hpvSource As Long, ByVal _
    cbCopy As Long)
     
Public Declare Function GetProcessHeap Lib "kernel32" () As Long

Public Declare Function HeapAlloc Lib "kernel32" _
    (ByVal hHeap As Long, ByVal dwFlags As Long, _
     ByVal dwBytes As Long) As Long
     
Public Declare Function HeapFree Lib "kernel32" _
    (ByVal hHeap As Long, _
     ByVal dwFlags As Long, _
     lpMem As Any) As Long

Private Const ERROR_SUCCESS As Long = 0

Private Type MIB_IPADDRROW
  dwAddr As Long        'IP address
  dwIndex As Long       'index of interface associated with this IP
  dwMask As Long        'subnet mask for the IP address
  dwBCastAddr As Long   'broadcast address (typically the IP
                        'with host portion set to either all
                        'zeros or all ones)
  dwReasmSize As Long   'reassembly size for received datagrams
  unused1 As Integer    'not currently used (but shown anyway)
  unused2 As Integer    'not currently used (but shown anyway)
End Type

Private Declare Function GetIpAddrTable Lib "IPHLPAPI.DLL" _
  (ByRef ipAddrTable As Byte, _
   ByRef dwSize As Long, _
   ByVal bOrder As Long) As Long
   
Private Declare Sub CopyMemory2 Lib "kernel32" Alias "RtlMoveMemory" _
  (dst As Any, src As Any, ByVal bcount As Long)
  
Private Declare Function inet_ntoa Lib "wsock32.dll" (ByVal addr As Long) As Long

Private Declare Function lstrcpyA Lib "kernel32" _
  (ByVal RetVal As String, ByVal Ptr As Long) As Long
                        
Private Declare Function lstrlenA Lib "kernel32" _
  (ByVal Ptr As Any) As Long
   
      
Private Function GetInetStrFromPtr(ByVal Address As Long) As String
On Error GoTo Hell
   GetInetStrFromPtr = GetStrFromPtrA(inet_ntoa(Address))

Exit Function
Hell:
Err.Clear
End Function


Private Function GetStrFromPtrA(ByVal lpszA As Long) As String
On Error GoTo Hell
   GetStrFromPtrA = String$(lstrlenA(ByVal lpszA), 0)
   Call lstrcpyA(ByVal GetStrFromPtrA, ByVal lpszA)

Exit Function
Hell:
Err.Clear
End Function


Public Function GetSubNetMask() As String
On Error GoTo Hell
   Dim IPAddrRow As MIB_IPADDRROW
   Dim buff() As Byte
   Dim cbRequired As Long
   Dim nStructSize As Long
   Dim nRows As Long
   Dim cnt As Long
   
   Call GetIpAddrTable(ByVal 0&, cbRequired, 1)

   If cbRequired > 0 Then
    
      ReDim buff(0 To cbRequired - 1) As Byte
      
      If GetIpAddrTable(buff(0), cbRequired, 1) = ERROR_SUCCESS Then
      
         nStructSize = LenB(IPAddrRow)
   
         CopyMemory2 nRows, buff(0), 4
      
         For cnt = 1 To nRows
         
            CopyMemory2 IPAddrRow, buff(4 + (cnt - 1) * nStructSize), nStructSize
            
                GetSubNetMask$ = GetInetStrFromPtr(IPAddrRow.dwMask)
            
          Next cnt
          
      End If
   End If

Exit Function
Hell:
Err.Clear
End Function


Public Function GetMACAddress() As String
On Error GoTo Hell
  'retrieve the MAC Address for the network controller
  'installed, returning a formatted string
   
   Const NCBASTAT As Long = &H33
   Const HEAP_ZERO_MEMORY As Long = &H8
   Const HEAP_GENERATE_EXCEPTIONS As Long = &H4
   Const NCBRESET As Long = &H32
   Dim Tmp As String
   Dim pASTAT As Long
   Dim NCB As NET_CONTROL_BLOCK
   Dim AST As ASTAT

  'The IBM NetBIOS 3.0 specifications defines four basic
  'NetBIOS environments under the NCBRESET command. Win32
  'follows the OS/2 Dynamic Link Routine (DLR) environment.
  'This means that the first NCB issued by an application
  'must be a NCBRESET, with the exception of NCBENUM.
  'The Windows NT implementation differs from the IBM
  'NetBIOS 3.0 specifications in the NCB_CALLNAME field.
   NCB.ncb_command = NCBRESET
   Call Netbios(NCB)
   
  'To get the Media Access Control (MAC) address for an
  'ethernet adapter programmatically, use the Netbios()
  'NCBASTAT command and provide a "*" as the name in the
  'NCB.ncb_CallName field (in a 16-chr string).
   NCB.ncb_callname = "*               "
   NCB.ncb_command = NCBASTAT
   
  'For machines with multiple network adapters you need to
  'enumerate the LANA numbers and perform the NCBASTAT
  'command on each. Even when you have a single network
  'adapter, it is a good idea to enumerate valid LANA numbers
  'first and perform the NCBASTAT on one of the valid LANA
  'numbers. It is considered bad programming to hardcode the
  'LANA number to 0 (see the comments section below).
   NCB.ncb_lana_num = 0
   NCB.ncb_length = Len(AST)
   
   pASTAT = HeapAlloc(GetProcessHeap(), HEAP_GENERATE_EXCEPTIONS _
            Or HEAP_ZERO_MEMORY, NCB.ncb_length)
            
   If pASTAT = 0 Then
      Exit Function
   End If
   
   NCB.ncb_buffer = pASTAT
   Call Netbios(NCB)
   
   CopyMemory AST, NCB.ncb_buffer, Len(AST)
   
   Tmp = Format$(Hex$(AST.adapt.adapter_address(0)), "00") & " " & _
         Format$(Hex$(AST.adapt.adapter_address(1)), "00") & " " & _
         Format$(Hex$(AST.adapt.adapter_address(2)), "00") & " " & _
         Format$(Hex$(AST.adapt.adapter_address(3)), "00") & " " & _
         Format$(Hex$(AST.adapt.adapter_address(4)), "00") & " " & _
         Format$(Hex$(AST.adapt.adapter_address(5)), "00")
           
   HeapFree GetProcessHeap(), 0, pASTAT
   
   GetMACAddress = Tmp

Exit Function
Hell:
GetMACAddress = Empty
Err.Clear
End Function
'--end block--'






